SystemOrganization addCategory: #'System-Settings-Browser'!
SystemOrganization addCategory: #'System-Settings-Core'!
SystemOrganization addCategory: #'System-Settings-Filter'!
SystemOrganization addCategory: #'System-Settings-Style'!

!Color class methodsFor: '*System-Settings-Browser' stamp: 'AlainPlantec 3/5/2010 09:33'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForColor! !

!AbstractFont class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:49'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForFont! !

!Association methodsFor: '*System-Settings-Browser' stamp: 'alain.plantec 3/24/2009 23:20'!
settingFixedDomainValueNodeFrom: aSettingNode 
	^ aSettingNode fixedDomainValueNodeForAssociation: self! !

DialogWindow subclass: #SettingPackageChooser
	uses: TMorphTreeModel
	instanceVariableNames: 'packageList selection settingBrowser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingPackageChooser commentStamp: 'alain.plantec 4/20/2009 21:38' prior: 0!
A SettingPackageChooser is a model for a PluggableListMorphOfMany view which allows the chosing of several packages from the list of all system packages. 

!

SettingPackageChooser class
	uses: TMorphTreeModel classTrait
	instanceVariableNames: ''!

!SettingPackageChooser class methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/29/2010 10:58'!
on: aSettingBrowser
	^ self new settingBrowser: aSettingBrowser! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 10:42'!
chosen
	^ self selection ifNil: [#()] ifNotNil: [:s | s selectedItemOrItemsOrNil ifNil: [#()]]! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 11:04'!
chosen: aList
	packageList buildContents.
	self selectItems: aList! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 09:56'!
deselectAll
	self selectItems: #()! !

!SettingPackageChooser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 21:33'!
deselectAllButton
	^ self newButtonFor: self
			getState: nil
			action: #deselectAll
			arguments: nil
			getEnabled: nil
			label: 'Deselect all' translated
			help: 'Deselect all packages' translated! !

!SettingPackageChooser methodsFor: 'user interface' stamp: 'alain.plantec 3/17/2009 22:12'!
initialExtent
	"Answer the initial extent for the receiver.
	Adjust the text if the text	would be wider than 1/4
	the display width."
	^ (super initialExtent x max: 250)
		@ 500! !

!SettingPackageChooser methodsFor: 'initialize-release' stamp: 'AlainPlantec 1/27/2010 13:21'!
initialize
	super initialize.
	self title: 'Choose packages'.
! !

!SettingPackageChooser methodsFor: 'user interface' stamp: 'AlainPlantec 1/30/2010 09:40'!
listMorph
	^ (packageList := MorphTreeMorph on: self) 
				multiSelection: true;
				autoDeselection: true;
				autoMultiSelection: true;
				itemSortBlock: [:a :b | a packageName < b packageName];
				itemStringGetter: [:item | item packageName];
				hResizing: #spaceFill;
				vResizing: #spaceFill! !

!SettingPackageChooser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 21:33'!
newButtons
	^ {self deselectAllButton}, super newButtons! !

!SettingPackageChooser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 09:45'!
newContentMorph
	^ self newColumn: {self listMorph}! !

!SettingPackageChooser methodsFor: 'initialize-release' stamp: 'AlainPlantec 1/30/2010 12:00'!
release
	packageList := selection := settingBrowser := nil.
	super release! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 11:35'!
rootItems
	^ settingBrowser allPackagesWithSettings
! !

!SettingPackageChooser methodsFor: 't - accessing' stamp: 'AlainPlantec 2/7/2010 22:44'!
rootNodeClassFromItem: anItem
	^ MorphTreeNodeModel! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 09:47'!
selection
	^ selection! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 09:48'!
setSelection: aSelection
	selection := aSelection! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 10:55'!
settingBrowser: aBrowser
	settingBrowser := aBrowser! !

!StrikeFont methodsFor: '*system-settings-browser' stamp: 'AlainPlantec 1/30/2010 14:48'!
settingStoreOn: aStream 
	aStream nextPut: $(.
	aStream nextPutAll: self class name.
	aStream nextPut: Character space.
	aStream nextPutAll: 'familyName: ''', self familyName, ''' pointSize: ', self pointSize asString, ' emphasized: ', self emphasis asString.
	aStream nextPut: $)
! !

!Number class methodsFor: '*System-Settings-Browser' stamp: 'alain.plantec 3/18/2009 15:09'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForNumber! !

!Point class methodsFor: '*System-Settings-Browser' stamp: 'alain.plantec 4/21/2009 09:57'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForPoint! !

!LogicalFont methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/19/2009 10:02'!
settingStoreOn: aStream 
	aStream nextPut: $(.
	aStream nextPutAll: self class name.
	aStream nextPut: Character space.
	aStream nextPutAll: 'familyName: '.
	self familyName settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'fallbackFamilyNames: '.
	self fallbackFamilyNames settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'pointSize: '.
	self pointSize settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'stretchValue: '.
	self stretchValue settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'weightValue: '.
	self weightValue settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'slantValue: '.
	self slantValue settingStoreOn: aStream.
	aStream nextPut: $)! !

!LogicalFont methodsFor: '*system-settings-browser' stamp: 'AlainPlantec 12/18/2009 08:55'!
withSizeIncrementedBy: anInteger
	^ LogicalFont 
		familyName: self familyName 
		fallbackFamilyNames: self fallbackFamilyNames
		pointSize: self pointSize + anInteger
		stretchValue: self stretchValue
		weightValue: self weightValue
		slantValue: self slantValue ! !

MorphTreeModel subclass: #SettingBrowser
	instanceVariableNames: 'viewedPackages roots status searchedText showSelectors treeHolder'
	classVariableNames: 'DefaultPragmaKeyword InitialExtent StyleNameClassSuffix UserStylePackageNamePrefix UserStylePackageNameSuffix'
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

SettingBrowser class
	instanceVariableNames: 'searchedTextList regexpSearch'!

!SettingBrowser commentStamp: 'AlainPlantec 2/4/2010 17:12' prior: 0!
A SettingBrowser view allow the browsing as well as the editing of setting values (Viewed setting are declared by a method with a particular pragma. See SettingManager comments to see which kinds of setting are available and how-to declare them).
For each setting, a label (which, according to a global switch, is its names or its method selector) is shown and along with the label, an input widget allowing the change of the setting value is also shown.

In order to know which settings are to be viewed, a setting browser must know the pragma keyword used to declare them. This is why a setting browser must be initialized with a set of regular expressions: all retained pragma keyword are matching at least one of the regular expression. Then, when opened, only settings which are declared with a retained pragma keyword are viewed.

Examples:
--------------------
(SettingBrowser forKeywords: #('blob.*')) open.
--------------------
Only settings which are declared with a keyword matching 'blob.*' regular expression are viewed.
Here is en example of such a setting declared in the class side of a class BlobSettings 
--------------------
BlobSettings class>>blob
	<blobSetting>
	^ SettingManager newNode: 'Blob parameters'
--------------------

In order to open a setting browser one can also use the simpler expression below:
--------------------
SettingBrowser browse: #('setting').
--------------------
It browses all settings declared with a pragma keyword which is matching the 'setting' regular expression.


A SettingBrowser view implements a filtering functionality. Two filtering modes are allowed: by token or by regular expression.
- by token: a sub-string is entered and, when accepted, only settings for which name, description, pragma class or method selector includes these token are viewed;
- by regular expression: the same as by token except that the input is used as a regular expression.

Instance Variables
	roots:		<Collection of SettingTreeNode>
	searchedText:		<String>
	status:		<WriteStream>
	collector:		<SettingCollector>

roots
	- the roots of the viewed setting trees

searchedText
	- the string used as a filter token or regexp in order to select viewed settings

status
	- a WriteStream used in order to store useful information which are shown when no current item is selected

collector
	- The SettingCollector which has the responsibility to collect settings and to build viewed trees
!

SettingBrowser class
	instanceVariableNames: 'searchedTextList regexpSearch'!

!SettingBrowser class methodsFor: 'opening' stamp: 'alain.plantec 4/13/2009 14:44'!
browse: aCollectionOfKeywordRegExp
	"open a SettingBrowser view which is able to browse all settings 
	that are declared with a pragma keyword which matches at least
	one of the regular expression contained in aCollectionOfKeywordRegExp
	example:
	(SettingBrowser browse: #('sett.*'))
	browse all settings which make use of a pragma keyword which matches
	the regular expression 'sett.*'.
	
	Note that the default setting pragma keyword is 'setting'
	and that the SystemSettingBrowser specialization is 
	dedicated to these settings.
	"
	(self forKeywords: aCollectionOfKeywordRegExp) open! !

!SettingBrowser class methodsFor: 'opening' stamp: 'alain.plantec 4/13/2009 14:33'!
forKeywords: aCollectionOfRegExps
	"create a new SettingBrowser initialized with a set of pragma keywords"
	^ self new acceptableKeywords: aCollectionOfRegExps! !

!SettingBrowser class methodsFor: 'settings' stamp: 'AlainPlantec 12/13/2009 22:54'!
initialExtent
	^ InitialExtent ifNil: [InitialExtent := 835@600]
		! !

!SettingBrowser class methodsFor: 'settings' stamp: 'alain.plantec 9/17/2009 21:44'!
initialExtent: aPoint
	InitialExtent := aPoint
		! !

!SettingBrowser class methodsFor: 'world menu' stamp: 'LaurentLaffont 6/21/2010 22:50'!
menuCommandOn: aBuilder
	<worldMenu>
	(aBuilder item: #'Settings')
		parent: #System;
		order: 1;
		icon: MenuIcons smallConfigurationIcon;
		action: [SettingBrowser open]; 
		help: 'Opens a SystemSettingBrowser which allows you to alter many system settings'! !

!SettingBrowser class methodsFor: 'opening' stamp: 'alain.plantec 4/13/2009 14:33'!
open
	"Open a SettingBrowser view"
	^ self new open! !

!SettingBrowser class methodsFor: 'updating' stamp: 'AlainPlantec 11/30/2009 10:22'!
refreshAllSettingBrowsers
	self allSubInstances do: [:sb | sb updateList]! !

!SettingBrowser class methodsFor: 'accessing' stamp: 'alain.plantec 4/20/2009 09:24'!
regexpSearch
	^ regexpSearch ifNil: [regexpSearch := false]! !

!SettingBrowser class methodsFor: 'accessing' stamp: 'alain.plantec 4/20/2009 09:24'!
regexpSearch: aBoolean
	regexpSearch := aBoolean! !

!SettingBrowser class methodsFor: 'accessing' stamp: 'alain.plantec 4/20/2009 09:18'!
searchedTextList
	^ searchedTextList ifNil: [searchedTextList := OrderedCollection new]! !

!SettingBrowser class methodsFor: 'settings' stamp: 'AlainPlantec 1/31/2010 16:34'!
styleNameClassSuffix
	^ StyleNameClassSuffix
		ifNil: [StyleNameClassSuffix := 'SettingStyle']! !

!SettingBrowser class methodsFor: 'settings' stamp: 'AlainPlantec 1/29/2010 21:26'!
styleNameClassSuffix: aString
	StyleNameClassSuffix := aString
! !

!SettingBrowser class methodsFor: 'settings' stamp: 'AlainPlantec 1/31/2010 16:38'!
userStyleOn: aBuilder 
	<systemsettings>
	(aBuilder group: #settingUserStyle) label: 'Settings user styles' translated;
		
		with: [(aBuilder setting: #styleNameClassSuffix) label: 'Classname suffix' translated;
				 description: 'A setting style is stored as a class which name is the style name suffixed with the value of this setting.
As an example, if the value of this setting is "SettingStyle" then, for a style named "Favorite", the corresponding style class name is "FavoriteSettingStyle".' translated.
			(aBuilder group: #'Package naming')
				with: [(aBuilder setting: #userStylePackageNamePrefix) label: 'Prefix' translated;
						 description: 'A setting style is stored as a class which name is the style name suffixed with the value of this setting.
As an example, if the value of this setting is "SettingStyle" then, for a style named "Favorite", the corresponding style class name is "FavoriteSettingStyle".' translated.
					(aBuilder setting: #userStylePackageNameSuffix) label: 'Suffix' translated;
						 description: 'A setting style is stored as a class which name is the style name suffixed with the value of this setting.
As an example, if the value of this setting is "SettingStyle" then, for a style named "Favorite", the corresponding style class name is "FavoriteSettingStyle".' translated]]! !

!SettingBrowser class methodsFor: 'settings' stamp: 'AlainPlantec 1/31/2010 16:35'!
userStylePackageNamePrefix
	^ UserStylePackageNamePrefix ifNil: [UserStylePackageNamePrefix := 'UserSettingStyle']! !

!SettingBrowser class methodsFor: 'settings' stamp: 'AlainPlantec 1/29/2010 21:26'!
userStylePackageNamePrefix: aString
	UserStylePackageNamePrefix := aString
! !

!SettingBrowser class methodsFor: 'settings' stamp: 'AlainPlantec 1/31/2010 16:35'!
userStylePackageNameSuffix
	^ UserStylePackageNameSuffix ifNil: [UserStylePackageNameSuffix := '']! !

!SettingBrowser class methodsFor: 'settings' stamp: 'AlainPlantec 1/29/2010 21:26'!
userStylePackageNameSuffix: aString
	UserStylePackageNameSuffix := aString
! !

!SettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 1/29/2010 21:22'!
about
	self inform: 'Here you can browse, query and change all system settings' translated! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:44'!
acceptableKeywords: aCollectionOfRegExps 
	self treeHolder acceptableKeywords: aCollectionOfRegExps ! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/23/2009 15:03'!
addToSearchedTextList: aString
	(self searchedTextList includes: aString) 
		ifFalse: [self searchedTextList size > 5 ifTrue: [self searchedTextList removeFirst].
		self searchedTextList add: aString]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 14:12'!
addToStatus: aText 
	self status nextPutAll: aText.
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 11:05'!
allPackagesWithSettings
	^( self treeHolder nodeList collect: [:n | n receiverPackage]) asSet! !

!SettingBrowser methodsFor: 'styles' stamp: 'AlainPlantec 1/31/2010 16:07'!
allStyleClasses
	^ ((((PragmaCollector
		filter: [:prag | prag keyword = 'settingstyle']) reset collected
		collect: [:p | p methodClass theNonMetaClass])
		reject: [:c | c = BuiltinSettingStyle]) asArray sort: [:a :b | a styleName < b styleName]) asOrderedCollection! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 1/30/2010 10:18'!
applyFilters
	roots := nil.
	self searchedText
		ifNotEmpty: [self updateAccordingTo: self textFilter].
	self viewedPackages
		ifNotEmpty: [ | filter |
			filter := SettingPackageFilter new
			packages: self viewedPackages.
			self updateAccordingTo: filter].
	self updateList
! !

!SettingBrowser methodsFor: 'styles' stamp: 'AlainPlantec 1/31/2010 16:02'!
browseStyle
	| cls |
	cls := UIManager default chooseFrom: (self allStyleClasses collect: [:c | c styleName]) values: self allStyleClasses.
	cls ifNotNil: [ToolSet browse: cls selector: nil]! !

!SettingBrowser methodsFor: 'styles' stamp: 'lr 3/14/2010 21:13'!
buildStyleNamed: aName classname: aClassname
	| declList styleClass |
	(Smalltalk globals includesKey: aClassname asSymbol)
		ifTrue: [ styleClass := Smalltalk globals at: aClassname ]
		ifFalse: [ 
			| newDefinition |
			newDefinition := BuiltinSettingStyle definition
				copyReplaceAll: '#' , BuiltinSettingStyle name asString
				with: '#' , aClassname.
			newDefinition := newDefinition copyReplaceAll: 'System-Settings-Style' with: self userStylePackageName.
			styleClass := Compiler evaluate: newDefinition logged: true.
			styleClass class instanceVariableNames: BuiltinSettingStyle class instanceVariablesString.
			styleClass copyAllCategoriesFrom: BuiltinSettingStyle.
			styleClass class copyAllCategoriesFrom: BuiltinSettingStyle class ].
	styleClass class compile: ('styleName\	<settingstyle>\	^ ''' , aName , '''') withCRs classified: #accessing.
	declList := (self treeHolder nodeList select: [ :node | node item hasValue and: [ node item allowedInStyle ] ])
		collect: [ :node | node item ].
	styleClass compileAllLoadMethodsFor: declList! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 21:08'!
buildWindowIn: aWindow 
	| statusView toolBar treeMorph toolBarY gap localGap menuBar menuBarY packageListView statusViewHeight |
	treeMorph := self treeMorphIn: aWindow.
	statusView := self statusViewIn: aWindow.
	statusViewHeight := 100.
	toolBar := self toolBarIn: aWindow.
	menuBar := self menuBarIn: aWindow.
	menuBar submorphs ifEmpty: [menuBarY := 0] 
	ifNotEmpty: [menuBarY := menuBar minExtent y.
	aWindow 
		addMorph: menuBar
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ menuBarY))].
	localGap := 5.
	gap := localGap + menuBarY.
	packageListView := self packageListViewIn: aWindow.
	toolBarY := toolBar minExtent y + gap.
	aWindow 
		addMorph: toolBar
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (gap ) corner: 0 @ (toolBarY + localGap))).
	aWindow 
		addMorph: treeMorph
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0.99)
				offsets: (0 @ (toolBarY + localGap + localGap) corner: 0 @ statusViewHeight negated)).
	aWindow 
		addMorph: statusView
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0.99 corner: 0.75 @ 1)
				offsets: (0 @ statusViewHeight negated corner: 0 @ 0)).
	aWindow 
		addMorph: packageListView
		fullFrame: (LayoutFrame 
				fractions: (0.75 @ 0.99 corner: 1 @ 1)
				offsets: (0 @ statusViewHeight negated corner: 0 @ 0)).
	^ aWindow! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 1/29/2010 21:08'!
changePackageSet: aSet 
	aSet ~= self viewedPackages
		ifTrue: [self viewedPackages: aSet.
			self applyFilters].
	^ true! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 4/23/2009 14:59'!
changeSearchedText: aString 
	self searchedText ~= aString
		ifTrue: [self searchedText: aString.
			self applyFilters].
	^ true ! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 21:08'!
choosePackagesIn: aWindow
	| chooser allPackages |
	allPackages := PackageOrganizer default packageNames asSortedCollection.
	aWindow openModal: (chooser := (SettingPackageChooser on: self) chosen: self viewedPackages; yourself).
	chooser cancelled
		ifFalse: [self changePackageSet: (chooser chosen asSet)] ! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 11/27/2009 22:09'!
closePathFrom: aSetting 
	(self settingNodeOfDeclaration: aSetting)
		ifNotNil: [:node | self changed: {#roots. #closeItemPath}, (node path collect: [:n | n withoutListWrapper])]! !

!SettingBrowser methodsFor: 'styles' stamp: 'lr 3/14/2010 21:13'!
defaultSettingStyleClass
	^ Smalltalk globals at: self defaultSettingStyleClassName ifAbsent: [  ]! !

!SettingBrowser methodsFor: 'styles' stamp: 'AlainPlantec 1/29/2010 21:22'!
defaultSettingStyleClassName
	^ #DefaultSettingStyle! !

!SettingBrowser methodsFor: 'styles' stamp: 'lr 3/14/2010 21:13'!
demoSettingStyleClass
	^ Smalltalk globals at: self demoSettingStyleClassName ifAbsent: [  ]! !

!SettingBrowser methodsFor: 'styles' stamp: 'AlainPlantec 1/31/2010 11:57'!
demoSettingStyleClassName
	^ #DemoSettingStyle! !

!SettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 12/1/2009 15:51'!
doubleClick
	self selectedNode ifNotNil: [:node | node browseDeclaration]! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
expandAll
	self changed: #(#roots #expandAll).
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 13:51'!
getDescription
	^ (self selectedNode)
		ifNil: [self status contents ifEmpty: ['Hit return in text fields to accept the input' translated]]
		ifNotNil: [:sel | (Text string: sel item label attribute: TextEmphasis bold), String cr, sel item description]! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 1/30/2010 10:10'!
getViewedPackageNames
	^ Text
		streamContents: [:s | self viewedPackages
				ifEmpty: [s nextPutAll: 'All packages' translated]
				ifNotEmpty: [:selections | 
					(selections asSet = self allPackagesWithSettings asSet)
						ifTrue: [s nextPutAll: 'All packages']
						ifFalse: [selections
								do: [:package | 
									s nextPutAll: package packageName.
									s nextPut: Character space]]]]! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 21:23'!
helpDeclaringAndManagingSettings
	"Open up a workspace with explanatory info in it about the Setting Browser"
	Workspace new
		contents: "SettingManager comment;" 'To be documented here later';
		openLabel: 'Declaring and managing settings' translated! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 21:23'!
helpMenuIn: aWindow
	| helpMenu |
	helpMenu := aWindow newMenu.
	helpMenu
		addToggle: 'About' translated
		target: self
		selector: #about.
	helpMenu lastItem font: aWindow theme menuFont.
	helpMenu
		addToggle: 'Declaring and managing settings' translated
		target: self
		selector: #helpDeclaringAndManagingSettings.
	helpMenu lastItem font: aWindow theme menuFont.
	^ helpMenu
! !

!SettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 9/21/2009 09:40'!
initialExtent
	^ self class initialExtent! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 12/1/2009 09:10'!
isRendered
	| renderingMorphs |
	renderingMorphs := SystemWindow allSubInstances select: [:sw | sw model = self].
	^ renderingMorphs anySatisfy: [:m | m owner notNil]! !

!SettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 11/26/2009 07:30'!
keyStroke: aCharacter from: aTreeMorph 
	self selectedNode
		ifNotNil: [:current | current keyStroke: aCharacter from: aTreeMorph.
			current settingDeclaration hasDefault
				ifTrue: [aCharacter = $d
						ifTrue: [^ self menuSetToDefault: current]].
			current settingDeclaration hasEditableList
				ifTrue: [aCharacter = $e
						ifTrue: [^ self menuEmptyList: current]]]! !

!SettingBrowser methodsFor: 'styles' stamp: 'AlainPlantec 1/31/2010 16:02'!
loadStyle
	|  cls |
	cls := UIManager default
				chooseFrom: (self allStyleClasses
						collect: [:c | c styleName])
				values: self allStyleClasses.
	cls
		ifNotNil: [cls new loadStyle.
			self changed: #getDescription]! !

!SettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 3/10/2010 07:51'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, 
	honoring the #shifted boolean"
	self selectedNode ifNotNil: [:current | current menu: menu shifted: b].
	menu addLine.
	(self selectedNode)
		ifNotNil: [:current | 
			current settingDeclaration hasDefault
				ifTrue: [menu
						add: 'Set to default (d)' translated
						target: self
						selector: #menuSetToDefault:
						argument: current].
			current settingDeclaration hasEditableList
				ifTrue: [menu
						add: 'Empty list (e)' translated
						target: self
						selector: #menuEmptyList:
						argument: current]].
	^ menu! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 21:24'!
menuBarIn: aWindow
	| menuBar |
	menuBar := aWindow newToolDockingBar.
	menuBar
		add: 'Style' translated
		font: aWindow theme menuBarFont
		icon: nil
		help: 'Style creation, loading or removal operations' translated
		subMenu: (self styleMenuIn: aWindow).
	menuBar addSpacer.
	menuBar
		add: 'Help' translated
		font: aWindow theme menuBarFont
		icon: nil
		help: nil
		subMenu: (self helpMenuIn: aWindow).
	^ menuBar
! !

!SettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 10/19/2009 14:49'!
menuEmptyList: aTreeNode
	| v |
	(v := aTreeNode settingDeclaration) hasEditableList 
		ifTrue: [v emptyList. self updateList]! !

!SettingBrowser methodsFor: 'menu' stamp: 'alain.plantec 10/19/2009 14:17'!
menuSetToDefault: aTreeNode
	| v |
	(v := aTreeNode settingDeclaration) hasDefault
		ifTrue: [(self confirm: 'Set to default value ?' translated)
				ifTrue: [v setToDefault. self updateList]]! !

!SettingBrowser methodsFor: 'styles' stamp: 'lr 3/14/2010 21:13'!
newStyle
	| name |
	name := UIManager default request: 'Give the new style name.' translated initialAnswer: 'MyOwn' translated.
	name
		ifNotNil: [ 
			name
				ifNotEmpty: [ 
					| clsName usedName |
					usedName := ''.
					name subStrings
						do: [ :s | 
							s at: 1 put: s first asUppercase.
							usedName := usedName , s ].
					clsName := (usedName , self class styleNameClassSuffix value asIdentifier: true) asSymbol.
					(Smalltalk globals at: clsName ifAbsent: [  ])
						ifNotNil: [ :cls | 
							UITheme current
								alertIn: World
								text: clsName , ' ' , 'already exists, sorry' translated
								title: 'Invalid new style name' translated
								configure: [ :d |  ] ].
					self buildStyleNamed: name classname: clsName ] ]! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 4/29/2010 17:51'!
newTreeHolder
	^ SettingTree new  acceptableKeywords: self settingsKeywords! !

!SettingBrowser methodsFor: 'user interface' stamp: 'nice 1/5/2010 15:59'!
open
	
	Cursor wait
		showWhile: [ | window |window := StandardWindow new model: self.
			window title: self windowTitle.
			self buildWindowIn: window.
			window themeChanged.
			window openInWorld.
			^ window]! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 10/19/2009 00:53'!
openPathFrom: aSetting
	(self settingNodeOfDeclaration: aSetting) ifNotNil: [:node |
		self changed: {#roots. #openItemPath}, (node path collect: [:n | n withoutListWrapper])]! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 21:10'!
packageListViewIn: aWindow
	^ aWindow
				newTextEditorFor: self
				getText: #getViewedPackageNames
				setText: #setViewedPackageNames:.
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/27/2009 23:04'!
pragmaErrorOccured: aPragmaError
	self setDescription: aPragmaError message, String cr! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/23/2009 15:01'!
regexpSearch
	^ self class regexpSearch! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/23/2009 15:02'!
regexpSearch: aBoolean
	self class regexpSearch: aBoolean.
	self applyFilters 
! !

!SettingBrowser methodsFor: 'dependents access' stamp: 'AlainPlantec 1/29/2010 21:10'!
release
	treeHolder release.
	treeHolder := nil.
	roots := nil.
	status := nil.
	searchedText := nil.
	viewedPackages := nil.
	super release.! !

!SettingBrowser methodsFor: 'styles' stamp: 'AlainPlantec 1/31/2010 16:04'!
removeStyle
	|  cls allStyleClasses |
	allStyleClasses := self allStyleClasses.
	allStyleClasses remove: self defaultSettingStyleClass.
	allStyleClasses remove: self demoSettingStyleClass.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [(UIManager confirm: 'Definitively remove style' translated,' "', cls styleName, '" ?')
		ifTrue: [Smalltalk removeClassNamed: cls name]]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 2/4/2010 17:15'!
rootNodes
	^ roots ifNil: [roots := self treeHolder settingTreeRoots]
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 2/4/2010 17:16'!
roots
	^ self rootNodes
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/8/2009 08:58'!
searchedText
	^ searchedText ifNil: [searchedText := '']! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
searchedText: aString
	searchedText := aString.
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/20/2009 09:19'!
searchedTextList
	^ self class searchedTextList! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 11/18/2009 08:28'!
selection: aSelectionHolder
	super selection: aSelectionHolder.
	self setDescription: ''.
	self changed: #getDescription
! !

!SettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 11/24/2009 11:44'!
setAllToDefault
	(self confirm: 'Set all to default value ?' translated) ifTrue: [
		self treeHolder nodeList do: [:node | node item hasDefault ifTrue: [node item setToDefault]].
		self updateList]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 14:12'!
setDescription: aText 
	self status reset.
	self addToStatus: aText.
	self changed: #getDescription! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 21:10'!
setViewedPackageNames: aText 
	| allViewed |
	allViewed := Set new.
	aText asString subStrings
		do: [:sub | (PackageOrganizer default
						packageNamed: sub
						ifAbsent: [])
				ifNotNil: [:pkg | allViewed add: pkg]].
	self changePackageSet: allViewed.
	self changed: #getViewedPackageNames
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:44'!
settingNodeOfDeclaration: aSettingDeclaration
	^ self treeHolder deeplyDetect: [:n | n settingDeclaration = aSettingDeclaration]! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 11/27/2009 22:08'!
settingValueChanged: aSetting 
	aSetting realValue = true
		ifTrue: [self openPathFrom: aSetting].
	aSetting realValue = false
		ifTrue: [self closePathFrom: aSetting].
	aSetting changed: #realValue.
	aSetting changed: #fontButtonLabel.
	aSetting changed: #index.
	aSetting changed: #content ! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 4/29/2010 17:51'!
settingsKeywords 
	^ ((PragmaCollector new filter: [:prg | prg keyword = #settingPragmaProcessor]) reset) collect: [:p | p method selector].
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/23/2009 14:54'!
showSelectors
	^ showSelectors ifNil: [showSelectors := false]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/23/2009 14:54'!
showSelectors: aBoolean
	showSelectors := aBoolean.
	self updateList ! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 14:11'!
status
	^ status ifNil: [status := String new writeStream]! !

!SettingBrowser methodsFor: 'user interface' stamp: 'alain.plantec 3/23/2009 18:38'!
statusViewIn: aMorph
	| statusView |
	statusView := aMorph
				newTextEditorFor: self
				getText: #getDescription
				setText: #setDescription:.
	^ statusView
 ! !

!SettingBrowser methodsFor: 'styles' stamp: 'AlainPlantec 1/29/2010 21:23'!
styleLoaded
	self updateList! !

!SettingBrowser methodsFor: 'menu' stamp: 'AlainPlantec 1/29/2010 21:24'!
styleMenuIn: aWindow
	| styleMenu |
	styleMenu := aWindow newMenu.
	styleMenu
		addToggle: 'New' translated
		target: self
		selector: #newStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Update' translated
		target: self
		selector: #updateStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Load' translated
		target: self
		selector: #loadStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Browse' translated
		target: self
		selector: #browseStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'remove' translated
		target: self
		selector: #removeStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	^ styleMenu! !

!SettingBrowser methodsFor: 'accessing' stamp: 'alain.plantec 10/19/2009 14:59'!
switchShowSelectors
	self showSelectors: self showSelectors not! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 21:24'!
taskbarIcon
	^ MenuIcons smallConfigurationIcon! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 4/23/2009 15:01'!
textFilter
	^ self regexpSearch
		ifFalse: [SettingTokenFilter new token: self searchedText]
		ifTrue: [SettingRegexpFilter new regexp: self searchedText] ! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 2/13/2010 16:55'!
toolBarIn: aMorph 
	| toolBar |
	toolBar := aMorph newToolbar: {
	aMorph
		newButtonFor: self
		getState: nil
		action: #expandAll
		arguments: nil
		getEnabled: nil
		label: 'Expand all' translated
		help: 'Expand all tree nodes' translated.
	aMorph newToolSpacer.
	aMorph newToolSpacer.
	aMorph newLabel: 'Search for: ' translated.
	(EditableDropListMorph
				on: self
				list: #searchedTextList
				selected: #searchedText
				changeSelected: #changeSearchedText:
				useIndex: false 
				addToList: #addToSearchedTextList:
				class: String
				getEnabled: nil) hResizing: #spaceFill; 
				ghostText: 'Hit return to accept' translated.
	aMorph
			newCheckboxFor: self
			getSelected: #regexpSearch
			setSelected: #regexpSearch:
			getEnabled: nil
			label: 'Regexp' 
			help: 'Filter according to a regular expression' translated.
	aMorph newToolSpacer.	
	aMorph newToolSpacer.
	(aMorph
				newButtonFor: self
				getState: nil
				action: #choosePackagesIn:
				arguments: {aMorph}
				getEnabled: nil
				label: 'Choose packages' translated 
				help: 'Select packages' translated).
	aMorph newToolSpacer}.
	^ toolBar! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 11/18/2009 08:31'!
treeChanged: anAnnounce
	roots := nil.
	self selection: nil.
	self updateList! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:42'!
treeHolder
	^ treeHolder
		ifNil: [treeHolder := self newTreeHolder whenChangedSend: #treeChanged: to: self; yourself]! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 2/4/2010 17:17'!
treeMorphIn: aMorph 
	| treeMorph |
	treeMorph := (MorphTreeMorph on: self)
				nodeListSelector: #roots;
				getMenuSelector: #menu:shifted:;
				keystrokeActionSelector: #keyStroke:from:;
				columns: {
					MorphTreeColumn new startWidth: 300; rowMorphGetSelector: #labelMorphFor:; yourself.
					MorphTreeColumn new rowMorphGetSelector: #inputMorphFor:;yourself
				};
				doubleClickSelector: #doubleClick;
				rowInset: 6;
				columnInset: 6;
				rowColorForEven: Color veryLightGray muchLighter;
				preferedPaneColor: Color veryLightGray lighter lighter;
				yourself.
	^ treeMorph buildContents! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 11/18/2009 08:27'!
updateAccordingTo: aFilter
	self selection: nil.
	self setDescription: ''.
	roots := nil.
	self updateList.
	[self roots
		do: [:r | r updateAccordingTo: aFilter].
	self roots
		removeAllSuchThat: [:n | n isEmpty
				and: [(aFilter keepSettingTreeNode: n) not]]]
		on: RegexSyntaxError
		do: [:ex | 
			self setDescription: 'Regular expression syntax error, see `documentation'' protocol of RxParser class for user''s guide'].
	self expandAll! !

!SettingBrowser methodsFor: 'updating' stamp: 'AlainPlantec 1/29/2010 21:12'!
updateList
	self isRendered ifTrue: [
		self treeHolder updateList.
		self changed: #roots.
		self changed: #getDescription.
		self changed: #getViewedPackageNames].	
! !

!SettingBrowser methodsFor: 'updating' stamp: 'alain.plantec 4/2/2009 14:12'!
updateStatusWith: aMessage
	self addToStatus: aMessage.
	self addToStatus: Character cr.
! !

!SettingBrowser methodsFor: 'styles' stamp: 'AlainPlantec 1/31/2010 16:11'!
updateStyle
	| allStyleClasses cls |
	allStyleClasses := self allStyleClasses.
	allStyleClasses remove: self defaultSettingStyleClass.
	allStyleClasses remove: self demoSettingStyleClass.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [self buildStyleNamed: cls styleName classname: cls name]! !

!SettingBrowser methodsFor: 'styles' stamp: 'AlainPlantec 1/31/2010 16:37'!
userStylePackageName
	| suffix |
	suffix := self class userStylePackageNameSuffix.
	suffix ifNotEmpty: [suffix := '-', suffix].
	^ (self class userStylePackageNamePrefix asIdentifier: true), suffix
! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 12/14/2009 13:06'!
viewedLabelOfSetting: aSettingDeclaration 
	| node |
	node := self settingNodeOfDeclaration: aSettingDeclaration.
	^ node 
		ifNil: [aSettingDeclaration label]
		ifNotNil: [self showSelectors
			ifTrue: [node methodClass name , '>>' , node selector]
			ifFalse: [(node allChildren notEmpty and: [aSettingDeclaration hasValue])
				ifTrue: [aSettingDeclaration label, '...'] 
				ifFalse: [aSettingDeclaration label]]]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 21:11'!
viewedPackages
	^ viewedPackages
		ifNil: [viewedPackages := Set new]! !

!SettingBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 1/30/2010 10:18'!
viewedPackages: aCollectionOfPackagesOrNil
	viewedPackages := aCollectionOfPackagesOrNil! !

!SettingBrowser methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 21:29'!
windowTitle
	^ 'Settings browser'! !

!Array methodsFor: '*System-Settings-Browser' stamp: 'AlainPlantec 1/31/2010 10:35'!
settingStoreOn: aStream 
	"Use the literal form if possible."

	self isLiteral
		ifTrue: 
			[aStream nextPut: $#; nextPut: $(.
			self do: 
				[:element | 
				element settingStoreOn: aStream.
				aStream space].
			aStream nextPut: $)]
		ifFalse: [super settingStoreOn: aStream]! !

MorphTreeNodeModel subclass: #SettingNode
	instanceVariableNames: 'parentName pragma contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingNode commentStamp: 'alain.plantec 4/20/2009 21:42' prior: 0!
A SettingTreeNode is used by a SettingCollector as a node for setting trees. Built trees can be viewed by a SettingBrowser

Instance Variables
	contents:		<Collection of SettingTreeNode>
	parentNode:		<SettingTreeNode or nil>

contents
	- the children

parentNode
	- the parent or nil if the node is a root
!

!SettingNode methodsFor: 'comparing' stamp: 'alain.plantec 3/3/2009 22:46'!
<= other
	^ self asString <= other asString! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 07:33'!
allChildren
	^ self model childrenOf: self.
! !

!SettingNode methodsFor: 'menu' stamp: 'alain.plantec 9/19/2009 09:14'!
browseDeclaration
	"open a browser on the method which defines myself"
	ToolSet browse: self methodClass class selector: self selector! !

!SettingNode methodsFor: 'checking' stamp: 'AlainPlantec 12/13/2009 21:59'!
checkForUnknownTarget
	self parentNode ifNotNil: [:p | item target ifNil: [item target: p item target].
		item targetSelector ifNil: [item targetSelector: p item targetSelector]].
	self allChildren do: [:c | c checkForUnknownTarget]! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 08:52'!
contents
	(self settingDeclaration hasValue
			and: [self settingValue = false])
		ifTrue: [^ OrderedCollection new]
		ifFalse: [^ contents 
				ifNil: [contents := self allChildren.
					self settingDeclaration ordering
						ifTrue: [contents := contents asArray sort: self model sortBlock].
					contents := self model retainedNodesFromList: contents asOrderedCollection]]! !

!SettingNode methodsFor: 'menu' stamp: 'alain.plantec 4/3/2009 07:59'!
deeplyDetect: aBlock 
	(aBlock value: self) ifTrue: [^ self].
	self contents do: [:sub | (sub deeplyDetect: aBlock) ifNotNil: [:found | ^ found]].
	^ nil! !

!SettingNode methodsFor: 'menu' stamp: 'alain.plantec 4/3/2009 07:57'!
deeplySelect: aBlock in: aCollection
	(aBlock value: self) ifTrue: [aCollection add: self].
	self contents do: [:sub | sub deeplySelect: aBlock in: aCollection].
	^ aCollection! !

!SettingNode methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 16:06'!
description
	^ self settingDeclaration description! !

!SettingNode methodsFor: 'menu' stamp: 'AlainPlantec 11/24/2009 15:24'!
exploreItem
	self settingDeclaration explore! !

!SettingNode methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 16:38'!
icon
	^ self settingDeclaration ifNotNil: [:d | d icon ] ! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/11/2009 09:46'!
inputMorphFor: aContainer
	^ self settingDeclaration 
		ifNotNil: [:v | v inputMorphFor: aContainer]! !

!SettingNode methodsFor: 'menu' stamp: 'AlainPlantec 11/24/2009 15:24'!
inspectItem
	self settingDeclaration inspect! !

!SettingNode methodsFor: 'testing' stamp: 'alain.plantec 3/17/2009 09:45'!
isEmpty
	^ self contents isEmpty! !

!SettingNode methodsFor: 'menu' stamp: 'alain.plantec 3/30/2009 22:56'!
keyStroke: aCharacter from: aTreeMorph 
	aCharacter = $b
		ifTrue: [self menuBrowse. ^ true].
	aCharacter = $i
		ifTrue: [self inspectItem. ^ true].
	aCharacter = $I
		ifTrue: [self exploreItem. ^ true].
	^ false
! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 14:13'!
labelMorphFor: aContainer
	^ self settingDeclaration 
		ifNotNil: [:v | v labelMorphFor: aContainer]! !

!SettingNode methodsFor: 'menu' stamp: 'AlainPlantec 3/10/2010 07:32'!
menu: menu shifted: b 
	menu
		add: 'Browse (b)' translated
		target: self
		selector: #browseDeclaration.
! !

!SettingNode methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 10:11'!
menuBrowse
	self browseDeclaration! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/3/2009 14:44'!
methodClass
	^ self pragma ifNotNil: [self pragma methodClass theNonMetaClass]! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/9/2009 07:52'!
order
	^ item order! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/9/2009 07:52'!
order: anInteger
	item order: anInteger! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/3/2009 14:46'!
package
	
	^ self methodClass ifNotNil: [:mc | PackageOrganizer default mostSpecificPackageOfClass: mc ifNone: []]! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 09:26'!
parent: aSymbol
	self parentName: aSymbol! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 09:27'!
parentName
	^ parentName
	! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 09:27'!
parentName: aSymbol
	parentName := aSymbol.
	! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 07:51'!
parentNode
	^ self model nodeNamed: self parentName! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 14:51'!
pragma
	^ pragma! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 07:38'!
pragma: aPragma
	pragma := aPragma! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 10:50'!
receiverPackage
	^ self settingReceiver
		ifNotNil: [PackageOrganizer default
				mostSpecificPackageOfClass: self settingReceiver class
				ifNone: []] ! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 12/3/2009 14:46'!
selector
	^ self pragma ifNotNil: [:p | p selector]! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 07:11'!
settingDeclaration
	^ self item! !

!SettingNode methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 10:50'!
settingReceiver
	^ item settingReceiver! !

!SettingNode methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 23:40'!
settingValue
	^ self settingDeclaration realValue
! !

!SettingNode methodsFor: 'updating' stamp: 'alain.plantec 9/18/2009 23:47'!
updateAccordingTo: aFilter 
	self contents do: [ :n | n updateAccordingTo: aFilter ].
	self contents removeAllSuchThat: [ :n | n isEmpty and: [ (aFilter keepSettingTreeNode: n) not ] ]! !

!StrikeFontSet methodsFor: '*system-settings-browser' stamp: 'AlainPlantec 1/31/2010 10:45'!
settingStoreOn: aStream 
	aStream nextPut: $(.
	aStream nextPutAll: self class name.
	aStream nextPut: Character space.
	aStream nextPutAll: 'familyName: ''', self familyName, ''' size: ', self pointSize asString, ' emphasized: ', self emphasis asString.
	aStream nextPut: $)
! !

!Boolean class methodsFor: '*System-Settings-Browser' stamp: 'alain.plantec 3/18/2009 14:48'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForBoolean! !

Object subclass: #BuiltinSettingStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Style'!

!BuiltinSettingStyle commentStamp: 'alain.plantec 4/23/2009 07:36' prior: 0!
A SettingStyle provides a mean to store the state of all system settings according to specific user preferences and/or to some particular using (demonstration style with big fonts, laptop/desktop used at home or at work ...). The only behavior of a style is implemented by its load method. Thus, a style can be loaded programmatically as follow:
------------------
MyStyle new loadStyle
------------------
Where MyStyle is a subclass of SettingStyle which can implement a load method as below:
------------------
MyStyle>>load
	"load change a set of settings with some prefered value"
	MorphicSettings haloEnabled value: true.
	...
------------------

The SystemSettingBrowser makes it possible to manage SettingStyle sub-classes (create/update/delete/load/browse). See SystemSettingBrowser comment. 

Instance Variables
	status:		<Stream>

status
	- a stream or nil: used when loading in order to report any error
!

!BuiltinSettingStyle class methodsFor: 'code building' stamp: 'AlainPlantec 1/31/2010 11:07'!
compileAllLoadMethodsFor: aCollectionOfDeclarations 
	aCollectionOfDeclarations
		do: [:decl | 
			| code |
			code := self individualMethodCodeForDeclaration: decl.
			self compile: code classified: self settingLoadMethodCategory]! !

!BuiltinSettingStyle class methodsFor: 'code building' stamp: 'AlainPlantec 1/31/2010 10:54'!
individualMethodCodeForDeclaration: decl 
	^ String
		streamContents: [:s | 
			s nextPutAll: 'load'
					, (decl name asIdentifier: true) , String cr;
				 tab.
			s nextPutAll: String tab , 'self loadSetting: #' , decl name , ' withBlock: '.
			s nextPut: $[;
				
				nextPutAll: (decl target isSymbol
						ifTrue: [decl target]
						ifFalse: [decl target name]);
				
				nextPutAll: (decl targetSelector
						ifNil: ['']
						ifNotNil: [' ' , decl targetSelector]);
				 nextPutAll: ' ' , decl setSelector , ' '.
			s nextPutAll: (self storedValueOfDeclaration: decl).
			s nextPutAll: '].';
				 cr]! !

!BuiltinSettingStyle class methodsFor: 'code building' stamp: 'AlainPlantec 1/31/2010 11:07'!
settingLoadMethodCategory
	^ 'setting loading'! !

!BuiltinSettingStyle class methodsFor: 'code building' stamp: 'AlainPlantec 1/31/2010 10:55'!
storedValueOfDeclaration: aSettingDeclaration
	^ String streamContents: [:s | aSettingDeclaration realValue settingStoreOn: s]
! !

!BuiltinSettingStyle class methodsFor: 'accessing' stamp: 'AlainPlantec 1/31/2010 15:47'!
styleName
	"The style name used by the SettingBrowser"
	<settingstyle>
	^ self subclassresponsibility ! !

!BuiltinSettingStyle methodsFor: 'loading' stamp: 'AlainPlantec 1/31/2010 16:09'!
load
	(self class methodsInCategory: self class settingLoadMethodCategory) do: [:m | self perform: m].
	SettingBrowser refreshAllSettingBrowsers
! !

!BuiltinSettingStyle methodsFor: 'loading' stamp: 'AlainPlantec 1/31/2010 15:28'!
loadSetting: aName withBlock: aBlock 
	aBlock
		on: Error
		do: [| message |
			message := 'Error while changing the setting: ' , aName.
			Transcript show: message , String cr] ! !

!BuiltinSettingStyle methodsFor: 'loading' stamp: 'AlainPlantec 1/31/2010 15:27'!
loadStyle
	[self load]
		on: Error
		do: [Transcript show: 'Error while loading Setting style ' , self class styleName, String cr.
			^ false].
	Transcript show: 'Setting style ' , self class styleName , ' loaded.' , String cr.
	^ true! !

BuiltinSettingStyle subclass: #DefaultSettingStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Style'!

!DefaultSettingStyle commentStamp: 'alain.plantec 4/20/2009 14:06' prior: 0!
A DefaultSettingStyle represents the default system style. System maintainers can use the SystemSettingBrowser in order to automatically build it. System users can load it in order to reset all standard settings according to their default state.

Instance Variables
!

!DefaultSettingStyle class methodsFor: 'code building' stamp: 'AlainPlantec 1/31/2010 10:56'!
storedValueOfDeclaration: aSettingDeclaration
	^ String streamContents: [:s | aSettingDeclaration defaultValue settingStoreOn: s]
! !

!DefaultSettingStyle class methodsFor: 'accessing' stamp: 'AlainPlantec 1/31/2010 15:48'!
styleName
	<settingstyle>
	^ 'Default'! !

!DefaultSettingStyle methodsFor: 'loading' stamp: 'AlainPlantec 1/31/2010 16:10'!
load
	super load.
	StrikeFont installDejaVu.
	SettingBrowser refreshAllSettingBrowsers! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadAllowBlockArgumentAssignment
		self loadSetting: #allowBlockArgumentAssignment withBlock: [Parser allowBlockArgumentAssignment: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadAllowUnderscoreAsAssignment
		self loadSetting: #allowUnderscoreAsAssignment withBlock: [Scanner allowUnderscoreAsAssignment: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadAnimateClosing
		self loadSetting: #animateClosing withBlock: [UITheme currentAnimationSettings animateClosing: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadAnimationDelay
		self loadSetting: #animationDelay withBlock: [UITheme currentAnimationSettings delay: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadAnimationNumberOfSteps
		self loadSetting: #animationNumberOfSteps withBlock: [UITheme currentAnimationSettings numberOfSteps: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadAutoMenuColor
		self loadSetting: #autoMenuColor withBlock: [UITheme currentSettings autoMenuColor: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadBalloonFont
		self loadSetting: #balloonFont withBlock: [StandardFonts balloonFont: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadBalloonHelpEnabled
		self loadSetting: #balloonHelpEnabled withBlock: [UITheme currentSettings balloonHelpEnabled: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadBlabEmail
		self loadSetting: #blabEmail withBlock: [NetworkSystemSettings blabEmail: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadBrowseWithPrettyPrint
		self loadSetting: #browseWithPrettyPrint withBlock: [CodeHolder browseWithPrettyPrint: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadButtonFont
		self loadSetting: #buttonFont withBlock: [StandardFonts buttonFont: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadCacheSize
		self loadSetting: #cacheSize withBlock: [FreeTypeCache current cacheSize: 5000].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadCaseSensitiveFinds
		self loadSetting: #caseSensitiveFinds withBlock: [ParagraphEditor caseSensitiveFinds: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'StephaneDucasse 3/17/2010 20:55'!
loadCheckChangesFileAvailability
		self loadSetting: #checkChangesFileAvailability withBlock: [SmalltalkImage checkChangesFileAvailability: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadCheckSourcesFileAvailability
		self loadSetting: #checkSourcesFileAvailability withBlock: [SmalltalkImage checkSourcesFileAvailability: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadCmdDotEnabled
		self loadSetting: #cmdDotEnabled withBlock: [UserInterruptHandler cmdDotEnabled: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadCodeFont
		self loadSetting: #codeFont withBlock: [StandardFonts codeFont: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadControlAltKeyDecodePolicy
		self loadSetting: #controlAltKeyDecodePolicy withBlock: [InputEventSensor controlAltKeyDecodePolicy: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadCpuWatcherEnabled
		self loadSetting: #cpuWatcherEnabled withBlock: [CPUWatcher cpuWatcherEnabled: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDebugPrintSpaceLog
		self loadSetting: #debugPrintSpaceLog withBlock: [ImageSegment debugPrintSpaceLog: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDebugShowDamage
		self loadSetting: #debugShowDamage withBlock: [WorldState debugShowDamage: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDecorateBrowserButtons
		self loadSetting: #decorateBrowserButtons withBlock: [CodeHolder decorateBrowserButtons: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDefaultFont
		self loadSetting: #defaultFont withBlock: [StandardFonts defaultFont: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDefaultYellowButtonMenuEnabled
		self loadSetting: #defaultYellowButtonMenuEnabled withBlock: [Morph defaultYellowButtonMenuEnabled: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDesktopColor
		self loadSetting: #desktopColor withBlock: [PolymorphSystemSettings desktopColor: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDesktopGradientDirection
		self loadSetting: #desktopGradientDirection withBlock: [PolymorphSystemSettings desktopGradientDirection: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDesktopGradientFillColor
		self loadSetting: #desktopGradientFillColor withBlock: [PolymorphSystemSettings desktopGradientFillColor: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDesktopGradientOrigin
		self loadSetting: #desktopGradientOrigin withBlock: [PolymorphSystemSettings desktopGradientOrigin: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDesktopImageFileName
		self loadSetting: #desktopImageFileName withBlock: [PolymorphSystemSettings desktopImageFileName: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDiffsInChangeList
		self loadSetting: #diffsInChangeList withBlock: [CodeHolder diffsInChangeList: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDiffsWithPrettyPrint
		self loadSetting: #diffsWithPrettyPrint withBlock: [CodeHolder diffsWithPrettyPrint: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadDisplayFullscreen
		self loadSetting: #displayFullscreen withBlock: [Display fullScreen: false].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadEditableStringMorph
		self loadSetting: #editableStringMorph withBlock: [StringMorph editableStringMorph: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadExtraDebuggerButtons
		self loadSetting: #extraDebuggerButtons withBlock: [Debugger extraDebuggerButtons: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadFadedBackgroundWindows
		self loadSetting: #fadedBackgroundWindows withBlock: [UITheme currentSettings fadedBackgroundWindows: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadFastDragging
		self loadSetting: #fastDragging withBlock: [UITheme currentSettings fastDragging: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadFlatMenu
		self loadSetting: #flatMenu withBlock: [UITheme currentSettings flatMenu: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadFullScreenMargin
		self loadSetting: #fullScreenMargin withBlock: [SystemWindow fullScreenMargin: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadGlyphContrast
		self loadSetting: #glyphContrast withBlock: [FreeTypeSettings current glyphContrast: 50].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadHaloEnclosesFullBounds
		self loadSetting: #haloEnclosesFullBounds withBlock: [HaloMorph haloEnclosesFullBounds: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadHaloFont
		self loadSetting: #haloFont withBlock: [StandardFonts haloFont: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadHintingSymbol
		self loadSetting: #hintingSymbol withBlock: [FreeTypeSettings current hintingSymbol: #Light].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadHttpProxyPort
		self loadSetting: #httpProxyPort withBlock: [HTTPSocket httpProxyPort: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadHttpProxyServer
		self loadSetting: #httpProxyServer withBlock: [HTTPSocket httpProxyServer: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadInfiniteUndo
		self loadSetting: #infiniteUndo withBlock: [CommandHistory infiniteUndo: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadKeepTaskListOpen
		self loadSetting: #keepTaskListOpen withBlock: [TasklistMorph keepOpen: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadKeyboardFocusOnMouseDown
		self loadSetting: #keyboardFocusOnMouseDown withBlock: [MorphicModel keyboardFocusOnMouseDown: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadListFont
		self loadSetting: #listFont withBlock: [StandardFonts listFont: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadLogDebuggerStackToFile
		self loadSetting: #logDebuggerStackToFile withBlock: [Debugger logDebuggerStackToFile: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadMenuFont
		self loadSetting: #menuFont withBlock: [StandardFonts menuFont: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadMenuWithIcons
		self loadSetting: #menuWithIcons withBlock: [UITheme currentSettings menuWithIcons: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadMonitorType
		self loadSetting: #monitorType withBlock: [FreeTypeSettings current monitorType: #LCD].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadMouseOverForKeyboardFocus
		self loadSetting: #mouseOverForKeyboardFocus withBlock: [MorphicModel mouseOverForKeyboardFocus: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadMustCheckForSlips
		self loadSetting: #mustCheckForSlips withBlock: [ChangeSet mustCheckForSlips: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadObjectExplorerShowIcons
		self loadSetting: #ObjectExplorerShowIcons withBlock: [ObjectExplorer showIcons: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadOptionalButtons
		self loadSetting: #optionalButtons withBlock: [CodeHolder optionalButtons: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadPolymorphDiffToolsUsedByDefault
		self loadSetting: #polymorphDiffToolsUsedByDefault withBlock: [PSMCPatchMorph usedByDefault: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadPreferGradientFill
		self loadSetting: #preferGradientFill withBlock: [UITheme currentSettings preferGradientFill: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadPreferRoundCorner
		self loadSetting: #preferRoundCorner withBlock: [UITheme currentSettings preferRoundCorner: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadProxyPassword
		self loadSetting: #proxyPassword withBlock: [NetworkSystemSettings proxyPassword: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadProxyUser
		self loadSetting: #proxyUser withBlock: [NetworkSystemSettings proxyUser: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadPurgeUndoOnQuit
		self loadSetting: #purgeUndoOnQuit withBlock: [CommandHistory purgeUndoOnQuit: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadRaiseWarning
		self loadSetting: #raiseWarning withBlock: [Deprecation raiseWarning: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadRestartAlsoProceeds
		self loadSetting: #restartAlsoProceeds withBlock: [Debugger restartAlsoProceeds: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadServerMode
		self loadSetting: #serverMode withBlock: [WorldState serverMode: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadShowAnnotationPane
		self loadSetting: #showAnnotationPane withBlock: [CodeHolder showAnnotationPane: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadShowBoundsInHalo
		self loadSetting: #showBoundsInHalo withBlock: [HaloMorph showBoundsInHalo: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadShowTaskbar
		self loadSetting: #showTaskbar withBlock: [TaskbarMorph showTaskbar: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadShowTextEditingState
		self loadSetting: #showTextEditingState withBlock: [PluggableTextMorph showTextEditingState: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadShowWarning
		self loadSetting: #showWarning withBlock: [Deprecation showWarning: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadShowWindowPreview
		self loadSetting: #showWindowPreview withBlock: [TaskbarMorph showWindowPreview: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadSmartUpdating
		self loadSetting: #smartUpdating withBlock: [CodeHolder smartUpdating: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadSoundEnabled
		self loadSetting: #soundEnabled withBlock: [SoundSettings soundEnabled: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadSoundThemeClass
		self loadSetting: #soundThemeClass withBlock: [PolymorphSystemSettings soundThemeClass: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadStyleNameClassSuffix
		self loadSetting: #styleNameClassSuffix withBlock: [SettingBrowser styleNameClassSuffix: 'SystemSettingsStyle'].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUiThemeClass
		self loadSetting: #uiThemeClass withBlock: [PolymorphSystemSettings uiThemeClass: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUpdateFontsAtImageStartup
		self loadSetting: #updateFontsAtImageStartup withBlock: [FreeTypeSettings updateFontsAtImageStartup: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUpdateFromServerAtStartup
		self loadSetting: #updateFromServerAtStartup withBlock: [AutoStart updateFromServerAtStartup: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUpdateSavesFile
		self loadSetting: #updateSavesFile withBlock: [Utilities updateSavesFile: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUpgradeIsMerge
		self loadSetting: #upgradeIsMerge withBlock: [MCConfiguration upgradeIsMerge: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUseAnimation
		self loadSetting: #useAnimation withBlock: [UITheme currentAnimationSettings useAnimation: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUseDesktopGradientFill
		self loadSetting: #useDesktopGradientFill withBlock: [PolymorphSystemSettings useDesktopGradientFill: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUseHTTPProxy
		self loadSetting: #useHTTPProxy withBlock: [NetworkSystemSettings useHTTPProxy: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUseLocale
		self loadSetting: #useLocale withBlock: [Locale activated: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUseMultipleUndo
		self loadSetting: #useMultipleUndo withBlock: [TextMorphEditor useMultipleUndo: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUseNetworkAuthentification
		self loadSetting: #useNetworkAuthentification withBlock: [NetworkSystemSettings useNetworkAuthentification: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUseThemeSounds
		self loadSetting: #useThemeSounds withBlock: [SoundSettings useThemeSounds: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUseUndo
		self loadSetting: #useUndo withBlock: [CommandHistory useUndo: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadUserStylePackageNamePrefix
		self loadSetting: #userStylePackageNamePrefix withBlock: [SettingBrowser userStylePackageNamePrefix: 'UserStyle'].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 16:36'!
loadUserStylePackageNameSuffix
		self loadSetting: #userStylePackageNameSuffix withBlock: [SettingBrowser userStylePackageNameSuffix: ''].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadWalkAlongDisplayedLine
		self loadSetting: #walkAlongDisplayedLine withBlock: [ParagraphEditor walkAlongDisplayedLine: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadWarningAllowed
		self loadSetting: #warningAllowed withBlock: [Parser warningAllowed: nil].
! !

!DefaultSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 11:30'!
loadWindowTitleFont
		self loadSetting: #windowTitleFont withBlock: [StandardFonts windowTitleFont: nil].
! !

BuiltinSettingStyle subclass: #DemoSettingStyle
	instanceVariableNames: ''
	classVariableNames: 'BaseFontSize'
	poolDictionaries: ''
	category: 'System-Settings-Style'!

!DemoSettingStyle class methodsFor: 'accessing' stamp: 'AlainPlantec 1/31/2010 15:48'!
styleName
	<settingstyle>
	^ 'DemoMode'! !

!DemoSettingStyle methodsFor: 'loading' stamp: 'AlainPlantec 1/31/2010 16:09'!
load
	FreeTypeFontProvider current updateFromSystem.
	super load.
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadAllowBlockArgumentAssignment
		self loadSetting: #allowBlockArgumentAssignment withBlock: [Parser allowBlockArgumentAssignment: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadAllowUnderscoreAsAssignment
		self loadSetting: #allowUnderscoreAsAssignment withBlock: [Scanner allowUnderscoreAsAssignment: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadAnimateClosing
		self loadSetting: #animateClosing withBlock: [UITheme currentAnimationSettings animateClosing: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadAnimationDelay
		self loadSetting: #animationDelay withBlock: [UITheme currentAnimationSettings delay: 8].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadAnimationNumberOfSteps
		self loadSetting: #animationNumberOfSteps withBlock: [UITheme currentAnimationSettings numberOfSteps: 20].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadAutoMenuColor
		self loadSetting: #autoMenuColor withBlock: [UITheme currentSettings autoMenuColor: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadBalloonFont
		self loadSetting: #balloonFont withBlock: [StandardFonts balloonFont: (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 20 stretchValue: 5 weightValue: 400 slantValue: 1)].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadBalloonHelpEnabled
		self loadSetting: #balloonHelpEnabled withBlock: [UITheme currentSettings balloonHelpEnabled: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadBlabEmail
		self loadSetting: #blabEmail withBlock: [NetworkSystemSettings blabEmail: ''].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadBrowseWithPrettyPrint
		self loadSetting: #browseWithPrettyPrint withBlock: [CodeHolder browseWithPrettyPrint: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadButtonFont
		self loadSetting: #buttonFont withBlock: [StandardFonts buttonFont: (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 16 stretchValue: 5 weightValue: 400 slantValue: 0)].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadCacheSize
		self loadSetting: #cacheSize withBlock: [FreeTypeCache current cacheSize: 5000].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadCaseSensitiveFinds
		self loadSetting: #caseSensitiveFinds withBlock: [ParagraphEditor caseSensitiveFinds: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadCheckChangesFileAvailability
		self loadSetting: #checkChangesFileAvailability withBlock: [SmalltalkImage checkChangesFileAvailability: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadCheckSourcesFileAvailability
		self loadSetting: #checkSourcesFileAvailability withBlock: [SmalltalkImage checkSourcesFileAvailability: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadCmdDotEnabled
		self loadSetting: #cmdDotEnabled withBlock: [UserInterruptHandler cmdDotEnabled: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadCodeFont
		self loadSetting: #codeFont withBlock: [StandardFonts codeFont: (LogicalFont familyName: 'DejaVu Sans Mono' fallbackFamilyNames: nil pointSize: 16 stretchValue: 5 weightValue: 400 slantValue: 0)].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadControlAltKeyDecodePolicy
		self loadSetting: #controlAltKeyDecodePolicy withBlock: [InputEventSensor controlAltKeyDecodePolicy: #FullMatching].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadCpuWatcherEnabled
		self loadSetting: #cpuWatcherEnabled withBlock: [CPUWatcher cpuWatcherEnabled: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDebugPrintSpaceLog
		self loadSetting: #debugPrintSpaceLog withBlock: [ImageSegment debugPrintSpaceLog: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDebugShowDamage
		self loadSetting: #debugShowDamage withBlock: [WorldState debugShowDamage: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDecorateBrowserButtons
		self loadSetting: #decorateBrowserButtons withBlock: [CodeHolder decorateBrowserButtons: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDefaultFont
		self loadSetting: #defaultFont withBlock: [StandardFonts defaultFont: (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 16 stretchValue: 5 weightValue: 400 slantValue: 0)].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDefaultYellowButtonMenuEnabled
		self loadSetting: #defaultYellowButtonMenuEnabled withBlock: [Morph defaultYellowButtonMenuEnabled: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDesktopColor
		self loadSetting: #desktopColor withBlock: [PolymorphSystemSettings desktopColor: (Color r: 0.967 g: 0.975 b: 0.979)].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDesktopGradientDirection
		self loadSetting: #desktopGradientDirection withBlock: [PolymorphSystemSettings desktopGradientDirection: #Radial].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDesktopGradientFillColor
		self loadSetting: #desktopGradientFillColor withBlock: [PolymorphSystemSettings desktopGradientFillColor: (Color r: 0.0 g: 0.351 b: 0.52)].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDesktopGradientOrigin
		self loadSetting: #desktopGradientOrigin withBlock: [PolymorphSystemSettings desktopGradientOrigin: #topLeft].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDesktopImageFileName
		self loadSetting: #desktopImageFileName withBlock: [PolymorphSystemSettings desktopImageFileName: ''].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDiffsInChangeList
		self loadSetting: #diffsInChangeList withBlock: [CodeHolder diffsInChangeList: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDiffsWithPrettyPrint
		self loadSetting: #diffsWithPrettyPrint withBlock: [CodeHolder diffsWithPrettyPrint: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadDisplayFullscreen
		self loadSetting: #displayFullscreen withBlock: [Display fullScreen: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadEditableStringMorph
		self loadSetting: #editableStringMorph withBlock: [StringMorph editableStringMorph: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadExtraDebuggerButtons
		self loadSetting: #extraDebuggerButtons withBlock: [Debugger extraDebuggerButtons: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadFadedBackgroundWindows
		self loadSetting: #fadedBackgroundWindows withBlock: [UITheme currentSettings fadedBackgroundWindows: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadFastDragging
		self loadSetting: #fastDragging withBlock: [UITheme currentSettings fastDragging: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadFlatMenu
		self loadSetting: #flatMenu withBlock: [UITheme currentSettings flatMenu: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadFullScreenMargin
		self loadSetting: #fullScreenMargin withBlock: [SystemWindow fullScreenMargin: -5].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadGlyphContrast
		self loadSetting: #glyphContrast withBlock: [FreeTypeSettings current glyphContrast: 50.0].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadHaloEnclosesFullBounds
		self loadSetting: #haloEnclosesFullBounds withBlock: [HaloMorph haloEnclosesFullBounds: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadHaloFont
		self loadSetting: #haloFont withBlock: [StandardFonts haloFont: (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 20 stretchValue: 5 weightValue: 400 slantValue: 1)].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadHintingSymbol
		self loadSetting: #hintingSymbol withBlock: [FreeTypeSettings current hintingSymbol: #Light].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadHttpProxyPort
		self loadSetting: #httpProxyPort withBlock: [HTTPSocket httpProxyPort: 80].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadHttpProxyServer
		self loadSetting: #httpProxyServer withBlock: [HTTPSocket httpProxyServer: ''].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadInfiniteUndo
		self loadSetting: #infiniteUndo withBlock: [CommandHistory infiniteUndo: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadKeepTaskListOpen
		self loadSetting: #keepTaskListOpen withBlock: [TasklistMorph keepOpen: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadKeyboardFocusOnMouseDown
		self loadSetting: #keyboardFocusOnMouseDown withBlock: [MorphicModel keyboardFocusOnMouseDown: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadListFont
		self loadSetting: #listFont withBlock: [StandardFonts listFont: (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 16 stretchValue: 5 weightValue: 400 slantValue: 0)].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadLogDebuggerStackToFile
		self loadSetting: #logDebuggerStackToFile withBlock: [Debugger logDebuggerStackToFile: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadMenuFont
		self loadSetting: #menuFont withBlock: [StandardFonts menuFont: (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 16 stretchValue: 5 weightValue: 400 slantValue: 0)].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadMenuWithIcons
		self loadSetting: #menuWithIcons withBlock: [UITheme currentSettings menuWithIcons: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadMonitorType
		self loadSetting: #monitorType withBlock: [FreeTypeSettings current monitorType: #LCD].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadMouseOverForKeyboardFocus
		self loadSetting: #mouseOverForKeyboardFocus withBlock: [MorphicModel mouseOverForKeyboardFocus: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadMustCheckForSlips
		self loadSetting: #mustCheckForSlips withBlock: [ChangeSet mustCheckForSlips: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadObjectExplorerShowIcons
		self loadSetting: #ObjectExplorerShowIcons withBlock: [ObjectExplorer showIcons: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadOptionalButtons
		self loadSetting: #optionalButtons withBlock: [CodeHolder optionalButtons: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadPolymorphDiffToolsUsedByDefault
		self loadSetting: #polymorphDiffToolsUsedByDefault withBlock: [PSMCPatchMorph usedByDefault: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadPreferGradientFill
		self loadSetting: #preferGradientFill withBlock: [UITheme currentSettings preferGradientFill: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadPreferRoundCorner
		self loadSetting: #preferRoundCorner withBlock: [UITheme currentSettings preferRoundCorner: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadProxyPassword
		self loadSetting: #proxyPassword withBlock: [NetworkSystemSettings proxyPassword: ''].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadProxyUser
		self loadSetting: #proxyUser withBlock: [NetworkSystemSettings proxyUser: ''].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadPurgeUndoOnQuit
		self loadSetting: #purgeUndoOnQuit withBlock: [CommandHistory purgeUndoOnQuit: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadRaiseWarning
		self loadSetting: #raiseWarning withBlock: [Deprecation raiseWarning: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadRestartAlsoProceeds
		self loadSetting: #restartAlsoProceeds withBlock: [Debugger restartAlsoProceeds: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadServerMode
		self loadSetting: #serverMode withBlock: [WorldState serverMode: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadShowAnnotationPane
		self loadSetting: #showAnnotationPane withBlock: [CodeHolder showAnnotationPane: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadShowBoundsInHalo
		self loadSetting: #showBoundsInHalo withBlock: [HaloMorph showBoundsInHalo: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadShowTaskbar
		self loadSetting: #showTaskbar withBlock: [TaskbarMorph showTaskbar: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadShowTextEditingState
		self loadSetting: #showTextEditingState withBlock: [PluggableTextMorph showTextEditingState: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadShowWarning
		self loadSetting: #showWarning withBlock: [Deprecation showWarning: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadShowWindowPreview
		self loadSetting: #showWindowPreview withBlock: [TaskbarMorph showWindowPreview: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadSmartUpdating
		self loadSetting: #smartUpdating withBlock: [CodeHolder smartUpdating: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadSoundEnabled
		self loadSetting: #soundEnabled withBlock: [SoundSettings soundEnabled: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadSoundThemeClass
		self loadSetting: #soundThemeClass withBlock: [PolymorphSystemSettings soundThemeClass: NullSoundTheme].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadStyleNameClassSuffix
		self loadSetting: #styleNameClassSuffix withBlock: [SettingBrowser styleNameClassSuffix: 'SystemSettingsStyle'].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUiThemeClass
		self loadSetting: #uiThemeClass withBlock: [PolymorphSystemSettings uiThemeClass: UIThemeWatery2].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUpdateFontsAtImageStartup
		self loadSetting: #updateFontsAtImageStartup withBlock: [FreeTypeSettings updateFontsAtImageStartup: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUpdateFromServerAtStartup
		self loadSetting: #updateFromServerAtStartup withBlock: [AutoStart updateFromServerAtStartup: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUpdateSavesFile
		self loadSetting: #updateSavesFile withBlock: [Utilities updateSavesFile: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUpgradeIsMerge
		self loadSetting: #upgradeIsMerge withBlock: [MCConfiguration upgradeIsMerge: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUseAnimation
		self loadSetting: #useAnimation withBlock: [UITheme currentAnimationSettings useAnimation: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUseDesktopGradientFill
		self loadSetting: #useDesktopGradientFill withBlock: [PolymorphSystemSettings useDesktopGradientFill: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUseHTTPProxy
		self loadSetting: #useHTTPProxy withBlock: [NetworkSystemSettings useHTTPProxy: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUseLocale
		self loadSetting: #useLocale withBlock: [Locale activated: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUseMultipleUndo
		self loadSetting: #useMultipleUndo withBlock: [TextMorphEditor useMultipleUndo: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUseNetworkAuthentification
		self loadSetting: #useNetworkAuthentification withBlock: [NetworkSystemSettings useNetworkAuthentification: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUseThemeSounds
		self loadSetting: #useThemeSounds withBlock: [SoundSettings useThemeSounds: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUseUndo
		self loadSetting: #useUndo withBlock: [CommandHistory useUndo: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadUserStylePackageNamePrefix
		self loadSetting: #userStylePackageNamePrefix withBlock: [SettingBrowser userStylePackageNamePrefix: 'UserStyle'].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 16:36'!
loadUserStylePackageNameSuffix
		self loadSetting: #userStylePackageNameSuffix withBlock: [SettingBrowser userStylePackageNameSuffix: ''].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadWalkAlongDisplayedLine
		self loadSetting: #walkAlongDisplayedLine withBlock: [ParagraphEditor walkAlongDisplayedLine: true].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadWarningAllowed
		self loadSetting: #warningAllowed withBlock: [Parser warningAllowed: false].
! !

!DemoSettingStyle methodsFor: 'setting loading' stamp: 'AlainPlantec 1/31/2010 14:46'!
loadWindowTitleFont
		self loadSetting: #windowTitleFont withBlock: [StandardFonts windowTitleFont: (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 18 stretchValue: 5 weightValue: 400 slantValue: 1)].
! !

!Object methodsFor: '*System-Settings-Browser' stamp: 'alain.plantec 3/24/2009 23:21'!
settingFixedDomainValueNodeFrom: aSettingNode 
	^ aSettingNode fixedDomainValueNodeForObject: self! !

!Object methodsFor: '*System-Settings-Browser' stamp: 'alain.plantec 3/19/2009 09:50'!
settingStoreOn: aStream
	^ self storeOn: aStream! !

Object subclass: #PragmaSetting
	instanceVariableNames: 'precondition target targetSelector name label description order icon ordering dialog allowedInStyle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!PragmaSetting commentStamp: 'alain.plantec 4/7/2009 22:59' prior: 0!
A PragmaSetting is a holder for a setting. A setting is declared in a class method which contains a pragma (as examples, <menu> or <setting>). 
Settings can be collected on the fly by a PragmaCollector and browsed by a SettingBrowser. Settings are organized in trees. The parent instance variable is set to nil when the setting is a root. Instances of concrete subclasses of PragmaSetting should not be created directly, instead, SettingManager must be used for that purpose. More documentation and examples of setting declaration are given in the SettingManager comment.

Instance Variables
	description:		<String> 
	name:				<String>
	parents:			<Collection of Symbol>
	order : 			<Number>

description
	- the description that is used in ballon help or by supporting tools (optional)

name
	- the name of the setting

parents
	- a collection of symbols, each symbol corresponds to a the method selector of a parent setting

order
	- aNumber which is used for sibling items ordering
!

!PragmaSetting methodsFor: 'comparing' stamp: 'alain.plantec 4/20/2009 15:18'!
= other 
	^ self species = other species
		and: [self name = other name]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 13:58'!
allowedInStyle
	^ allowedInStyle ifNil: [allowedInStyle := self hasValue]! !

!PragmaSetting methodsFor: 'user interface' stamp: 'alain.plantec 3/11/2009 15:38'!
asString
	^ self name! !

!PragmaSetting methodsFor: 'user interface' stamp: 'SeanDeNigris 4/21/2010 15:19'!
chooseFileDirectory
	| result |
	result := UITheme current chooseDirectoryIn: World title: 'Choose a file' path: nil.
	result ifNotNil: [ self realValue: result fullName ].! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 14:12'!
chooseFilePath
	| result |
	result := UITheme current fileOpenIn: World title: 'Choose a file' extensions: nil path: nil preview: true.
	result 
		ifNotNil: [
			self realValue: result name. 
			result close]! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 14:01'!
defaultIcon
	^ MenuIcons smallConfigurationIcon! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/13/2009 15:52'!
description
	"Answer the value of description"

	^ description ifNil: [description := '']! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 19:36'!
description: aText
	"Set the value of description"

	description := aText! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 1/30/2010 08:07'!
dialog
	^ dialog! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 1/30/2010 07:59'!
dialog: aValuable
	dialog := aValuable! !

!PragmaSetting methodsFor: 'user interface' stamp: 'alain.plantec 3/12/2009 12:58'!
enabled
	^ true! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 14:12'!
fontButtonLabel
	| emphases |
	emphases := IdentityDictionary new at: nil put: 'Regular' translated;
				 at: 0 put: 'Regular' translated;
				 at: 1 put: 'Bold' translated;
				 at: 2 put: 'Italic' translated;
				 at: 4 put: 'Underlined' translated;
				 at: 8 put: 'Narrow' translated; 
				 at: 16 put: 'StruckOut' translated;
				 yourself.
	^ StringMorph contents: self realValue familyName , ' '
			, (emphases
					at: self realValue emphasis
					ifAbsent: ['']) , ' ' , self realValue pointSize asString font: self realValue! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 14:12'!
getFont
	^ FontChooser
		openWithWindowTitle: 'Font for ' , self name
		for: self
		setSelector: #realValue:
		getSelector: #realValue ! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 14:02'!
hasDefault
	^ false! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 14:03'!
hasEditableList
	^ false! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 14:03'!
hasValue
	^ false! !

!PragmaSetting methodsFor: 'comparing' stamp: 'alain.plantec 4/20/2009 15:19'!
hash
	^ self species hash bitXor: self name hash ! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 08:27'!
icon
	^ icon ifNil: [icon := self defaultIcon]! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 11/23/2009 22:18'!
icon: aForm 
	icon := aForm! !

!PragmaSetting methodsFor: 'user interface' stamp: 'alain.plantec 4/9/2009 01:32'!
inputMorphFor: aContainer 
	^ self inputWidget
		ifNotNil: [:iw | 
			(UITheme current newRowIn: World for: {iw})
				 clipSubmorphs: true;
				 hResizing: #shrinkWrap;
				 cellInset: 0;
				 yourself]! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 1/30/2010 08:07'!
inputWidget
	"return the default widget for the input a the setting"
	^ self dialog
		ifNotNil: [:d | d numArgs = 0
				ifTrue: [d value]
				ifFalse: [d value: self]] ! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 14:11'!
label
	^ label ifNil: [self name] ifNotNil: [label value]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 14:11'!
label: aStringOrBlockOrMessageSend
	label := aStringOrBlockOrMessageSend! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 11/29/2009 22:22'!
labelMorphFor: aContainer
	^ StringMorph contents: (aContainer model viewedLabelOfSetting: self)! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 10/18/2009 12:40'!
name
	^ name ifNil: [super name] ifNotNil: [name value]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 10/18/2009 12:39'!
name: aNameOrBlockOrMessageSend
	name := aNameOrBlockOrMessageSend! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 08:18'!
noOrdering
	ordering := false! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 14:04'!
notInStyle
	allowedInStyle := false! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 11:59'!
order
	^ order! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 4/2/2009 10:53'!
order: aNumber
	order := aNumber! !

!PragmaSetting methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 08:18'!
ordering
	^ ordering ifNil: [ordering := true]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 08:42'!
precondition
	^ precondition ifNil: [precondition := [true]].! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 08:43'!
precondition: aValuable
	precondition := aValuable! !

!PragmaSetting methodsFor: 'accessing' stamp: 'lr 3/14/2010 21:13'!
realTarget
	^ target isSymbol
		ifTrue: [ Smalltalk globals at: target ifAbsent: [  ] ]
		ifFalse: [ target ]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 10:47'!
settingReceiver
	^ self targetSelector ifNil: [self realTarget] ifNotNil: [self realTarget perform: self targetSelector]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 12/2/2009 16:40'!
target
	^ target! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 21:15'!
target: anObject
	target := anObject! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 21:15'!
targetSelector
	^ targetSelector! !

!PragmaSetting methodsFor: 'accessing' stamp: 'AlainPlantec 11/26/2009 21:16'!
targetSelector: aSelector
	targetSelector := aSelector! !

PragmaSetting subclass: #SettingDeclaration
	instanceVariableNames: 'getSelector setSelector type default ghostHelp'
	classVariableNames: 'ValueListCache'
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SettingDeclaration commentStamp: 'alain.plantec 4/7/2009 23:04' prior: 0!
A SettingValue is an handler for a writtable setting value. 
Its main responsibility is allow real value changing and to hold descriptive data about the setting. When the real value is changed, all declared listeners are notified. The standard event mechanism is used for that purpose. See #value: method which is call in order to change a setting value. Whatever object can declare its interest in the real value changes by sending #whenChangedSend:to: to a setting. See notification protocol.

For convenience, my olds values are registered in a list. This list is used by the SystemSettingBrowser in order to easily retrieve previous values.

The type instance variable is a Symbol. It is used by the SystemSettingBrowser in order to build the input widget of a setting.
It can be the name of the class or the name of a superclass of the value. In that case, the input widget is built by #settingInputWidgetForNode: implemented by the class which name is the value of the type instance variable. As an example, the input widget for a Boolean is built by Boolean class>>settingInputWidgetForNode:.

Type value is not limited to be a class name. It can also be whatever symbol. In that case, the selector corresponding to the message to send to the setting in order to build the inputWidget is built by SettingValue>>localInputWidgetSelector. If the type instance variable is not set, then it is dynamically set to the class name of the value. 

See SettingManager comment for more explanations.

Instance Variables
	type:			<Symbol>
	default:		<anObject>
	list:			<Collection>
!

SettingDeclaration subclass: #MultipleSettingDeclaration
	instanceVariableNames: 'domainValues getter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!MultipleSettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/30/2009 14:30'!
domainValues
	^ getter
		ifNil: [domainValues ifNil: [domainValues := OrderedCollection new]]
		ifNotNil: [getter value asOrderedCollection collect: [:v | v settingFixedDomainValueNodeFrom: self]]! !

!MultipleSettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 22:09'!
domainValues: aCollection 
	domainValues := aCollection asArray collect: [ :v | v settingFixedDomainValueNodeFrom: self]! !

!MultipleSettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 22:09'!
domainValuesGetter: aValuable 
	self getter: aValuable! !

!MultipleSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 22:09'!
domainValuesLabels
	^ self domainValues
		collect: [:f | f name]! !

!MultipleSettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 22:09'!
getter: aValuable 
	getter := aValuable! !

!MultipleSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 22:09'!
hasEditableList
	^ false! !

MultipleSettingDeclaration subclass: #PickOneSettingDeclaration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!PickOneSettingDeclaration commentStamp: 'AlainPlantec 11/26/2009 14:16' prior: 0!
A CheckListSettingDeclaration is a setting for which the value domain is a list. Each element of the list is an instance of FixedSettingValue. If domainValues is set, then the list of valid values is constant (initialized at declaration time). Instead, if getter is set, then the setting list is always dynamically computed. See SettingManager comment for more explanations. 


Instance Variables
	domainValues:		<Collection>
	getter:			<MessageSend or Block>

domainValues
	- nil if getter is set, The collection of FixedSettingValue which declares all valid values for the setting if getter is not set

getter
	- nil if domainValues is set, a valuable which return the domain values if domainValues is not set
!

!PickOneSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/30/2009 14:23'!
chooseValue
	| chosen |
	chosen := UIManager default
				chooseFrom: self domainValuesLabels
				values: self domainValues
				title: self label translated, ' choices' translated.
	chosen
		ifNotNil: [self realValue: chosen realValue]! !

!PickOneSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 10/17/2009 23:47'!
content
	^ (self domainValues
		detect: [:v | v realValue = self realValue]
		ifNone: [^ 'nil']) name! !

!PickOneSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 10/17/2009 23:44'!
index
	self realValue ifNil: [self realValue: self default].
	^ self domainValues indexOf: (self domainValues detect: [:dv | dv realValue = self realValue] ifNone: [^ 0])! !

!PickOneSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 10/17/2009 23:39'!
index: anInteger
	self realValue: (self domainValues at: anInteger) realValue.
! !

!PickOneSettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 14:03'!
inputWidget
	| widget font row |
	font := UITheme current textFont.
	getter
		ifNil: [row := UITheme current newRowIn: World for: {
				widget := (UITheme current
						newDropListIn: World
						for: self
						list: #domainValuesLabels
						getSelected: #index
						setSelected: #index:
						getEnabled: #enabled
						useIndex: true
						help: self description)
						extent: 1 @ 30}.
					font := widget font]
		ifNotNil: [row := UITheme current newRowIn: World for: {
					widget := (UITheme current
						newTextEntryIn: World
						for: self
						get: #content
						set: nil
						class: String
						getEnabled: #enabled
						help: nil) lock; yourself.
					(UITheme current
						newButtonIn: World
						for: self
						getState: nil
						action: #chooseValue
						arguments: {}
						getEnabled: #enabled
						getLabel: nil
						help: 'Choose a value for ' translated , self name translated) label: '...';
						 cornerStyle: #square;
						 yourself}.
					row cellInset: 0].
	widget hResizing: #rigid.
	widget width: (self maxNameWidthForFont: font) + 50.
	^ row! !

SettingDeclaration subclass: #RangeSettingDeclaration
	instanceVariableNames: 'range'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!RangeSettingDeclaration commentStamp: 'alain.plantec 4/7/2009 23:03' prior: 0!
A RangeSettingValue is a setting for which the value domain is an interval.  See SettingManager comment for more explanations.

Instance Variables
	range:		<Interval>

range
	- The interval which define the value domain
!

!RangeSettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:57'!
hasEditableList
	^ false! !

!RangeSettingDeclaration methodsFor: 'user interface' stamp: 'simon.denier 6/11/2010 14:48'!
inputWidget
	^ (UITheme current newRowIn: World for: {(UITheme current
							newTextEntryIn: World 
							for: self
							get: #realValue
							set: #realValue:
							class: (Smalltalk globals at: self type)
							getEnabled: #enabled
							help: nil) hResizing: #rigid;
							width: 80;
							wantsFrameAdornments: true;
							yourself. 
						(PluggableSliderMorph new max: self range last;
							 min: self range first;
							 quantum: self range increment;
							on: self
							getValue: #realValue
							setValue: #realValue:) hResizing: #spaceFill;
							 vResizing: #spaceFIll;
							 setBalloonText: self description;
							 minWidth: 300; height: 20;
							 yourself}) 
				cellInset: 10;
				yourself! !

!RangeSettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 3/12/2009 16:19'!
range
	^ range ! !

!RangeSettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 3/3/2009 09:38'!
range: anInterval
	range := anInterval! !

!RangeSettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 10:48'!
realValue: aValue
	aValue
		ifNil: [self settingReceiver perform: self setSelector with: nil]
		ifNotNil: [self settingReceiver perform: self setSelector with: ((aValue max: self range first) min: self range last)].
	self triggerEvent: self privateChangeEvent with: self
	! !

!SettingDeclaration class methodsFor: 'icon accessing' stamp: 'alain.plantec 4/9/2009 00:15'!
nullifyForm
	^ (Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 463732736 4285815129 4285815129 4285815129 4285815129 4285815129 2292449280 463732736 0 0 0 0 0 0 0 1688469504 4285815129 4278190080 4278190080 4278190080 4278190080 4278190080 4280091395 4285815129 1688469504 0 0 0 0 0 1688469504 4285815129 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4285815129 1688469504 0 0 0 463732736 4285815129 4278190080 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 4278190080 4285815129 463732736 0 0 4285815129 4278190080 4278190080 4294967295 4294967295 4294967295 4278190080 4278190080 4294967295 4294967295 4294967295 4278190080 4285815129 4285815129 0 0 4285815129 4278190080 4278190080 4278190080 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4278190080 4285815129 0 0 4285815129 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4285815129 0 0 4285815129 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4285815129 0 0 4285815129 4278190080 4278190080 4278190080 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278190080 4278190080 4278190080 4285815129 0 0 2292449280 4281927174 4280025345 4294967295 4294967295 4294967295 4278190080 4278190080 4294967295 4294967295 4294967295 4278190080 4283696903 4285815129 0 0 463732736 4285815129 4278190080 4294967295 4294967295 4278190080 4278190080 4278190080 4278190080 4294967295 4294967295 4278190080 4285815129 463732736 0 0 0 1688469504 4285815129 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4278190080 4285815129 1688469504 0 0 0 0 0 1688469504 4285815129 4285815129 4278190080 4278190080 4278190080 4278190080 4283696646 4285815129 1688469504 0 0 0 0 0 0 0 463732736 2292449280 4285815129 4285815129 4285815129 4285815129 2292449280 463732736 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!SettingDeclaration class methodsFor: 'icon accessing' stamp: 'alain.plantec 4/8/2009 17:40'!
smallCautionForm
	^ (Form
	extent: 16@16
	depth: 32
	fromArray: #( 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 463732736 2292449280 3517186048 4154720256 4154720256 3517186048 2292449280 463732736 0 0 0 0 0 0 0 1688469504 4137943040 4292614939 4293600292 4293534756 4293534499 4293402913 4292483352 4137943040 1688469504 0 0 0 0 0 1688469504 4290185224 4293600292 4292284175 4291428866 4291166208 4291100672 4291297794 4292087053 4293271070 4290184967 1688469504 0 0 0 463732736 4137943040 4293534756 4291823367 4291231744 4291166208 4294967295 4294967295 4290969600 4290969600 4291429637 4293073948 4137943040 463732736 0 0 2292449280 4292614682 4292284175 4291231744 4291035136 4291035136 4294967295 4294967295 4291035136 4291035136 4290838528 4291824395 4292351253 2292449280 0 0 3517186048 4293468963 4291363330 4291166208 4291035136 4291035136 4294967295 4294967295 4291035136 4291035136 4290707456 4290838785 4292942105 3517186048 0 0 4154720256 4293534242 4291166208 4291100672 4291035136 4291035136 4294967295 4294967295 4291035136 4290707456 4290641920 4290641920 4292942104 4154720256 0 0 4154720256 4293468449 4291035136 4291035136 4291035136 4291035136 4291100672 4291100672 4291035136 4290641920 4290576384 4290510848 4292876056 4154720256 0 0 3517186048 4293271328 4291166722 4290969600 4291035136 4291035136 4291035136 4291035136 4291035136 4291035136 4290510848 4290576641 4292744726 3517186048 0 0 2292449280 4292417303 4291955981 4290838528 4291035136 4291035136 4294967295 4294967295 4291035136 4291035136 4290445312 4291430665 4292088338 2292449280 0 0 463732736 4137943040 4293139484 4291298565 4290707456 4290641920 4294967295 4294967295 4290510848 4290379776 4290905092 4292678933 4137943040 463732736 0 0 0 1688469504 4290184967 4293007898 4291693323 4290707713 4290510848 4290445312 4290511105 4291365129 4292678932 4290053638 1688469504 0 0 0 0 0 1688469504 4137943040 4292219924 4292876311 4292876055 4292810518 4292744726 4292088081 4137943040 1688469504 0 0 0 0 0 0 0 463732736 2292449280 3517186048 4154720256 4154720256 3517186048 2292449280 463732736 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!SettingDeclaration class methodsFor: 'cache accessing' stamp: 'alain.plantec 9/18/2009 09:57'!
valueListCache
	^ ValueListCache ifNil: [ValueListCache := WeakKeyDictionary new]! !

!SettingDeclaration class methodsFor: 'cache accessing' stamp: 'AlainPlantec 1/29/2010 10:50'!
valueListFor: aSettingValue
	| targetEntry |
	targetEntry := self valueListCache at: aSettingValue settingReceiver ifAbsentPut: [IdentityDictionary new].
	^ targetEntry at: aSettingValue getSelector ifAbsentPut: [OrderedCollection new].! !

!SettingDeclaration methodsFor: 'comparing' stamp: 'AlainPlantec 12/2/2009 16:44'!
= other
	self class = other class
		ifFalse: [^ false].
	self target == other target ifFalse: [^ false].
	self targetSelector = other targetSelector ifFalse: [^ false].
	self getSelector = other getSelector ifFalse: [^ false].
	self setSelector = other setSelector ifFalse: [^ false].
	^ true
	
! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/9/2009 09:41'!
addToList: anItem
	(self list includes: anItem)
		ifFalse: [self list size > self maxKept
				ifTrue: [self list removeFirst].
			self list add: anItem.
			self changed: #list]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 19:40'!
default
	^ default ! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 09:13'!
default: anObject 
	"initialize the default value"
	default := anObject.
! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/5/2009 14:40'!
defaultIcon
	^ (self type = #LogicalFont or: [self realValue isKindOf: AbstractFont])
		ifTrue: [MenuIcons smallFontsIcon]
		ifFalse: [MenuIcons smallPaintIcon]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 11:48'!
defaultValue
	^ default value! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/19/2009 09:18'!
emptyList
	self list removeAll.
	self value ifNotNil: [self addToList: self realValue].! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 17:01'!
fixedDomainValueNodeForAssociation: anAssociation 
	| s |
	^ (s := (SettingDeclaration new name: anAssociation key))
		target: s;
		selector: #default;
		default: anAssociation value! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 12/2/2009 17:01'!
fixedDomainValueNodeForObject: anObject 
	| s |
	^ (s := (SettingDeclaration new name: anObject asString))
		target: s;
		selector: #default;
		default: anObject! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 22:35'!
getSelector
	^ getSelector ifNil: [self name]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 23:07'!
getSelector: aSymbol
	getSelector := aSymbol! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 23:52'!
ghostHelp
	^ ghostHelp ! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 23:52'!
ghostHelp: aString
	ghostHelp := aString! !

!SettingDeclaration methodsFor: 'testing' stamp: 'alain.plantec 4/8/2009 16:59'!
hasDefault
	^ true! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 3/7/2010 14:34'!
hasEditableList
	^ (self realValue isKindOf: Boolean) not! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:50'!
hasPrivateListener
	^ self hasActionForEvent: self privateChangeEvent! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/25/2009 08:22'!
hasValue
	^ true! !

!SettingDeclaration methodsFor: 'comparing' stamp: 'AlainPlantec 12/13/2009 08:55'!
hash
	"hash is re-implemented because #= is re-implemented"
	^ self target hash
		bitXor: (self targetSelector hash
				bitXor: (self getSelector hash bitXor: self setSelector hash)) ! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/18/2009 23:20'!
index
	^ self list
		indexOf: self realValue
		ifAbsent: [self realValue
				ifNil: [0]
				ifNotNil: [self addToList: self realValue.
					self list size]]! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/18/2009 09:44'!
index: anInteger 
	self realValue: (self list at: anInteger)! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 5/20/2009 12:24'!
inputMorphFor: aContainer
	^ (super inputMorphFor: aContainer)
		ifNotNil: [:im |			
				self whenPrivateChangedSend: #settingValueChanged: to: aContainer model.
				self whenPrivateChangedSend: #innerWidgetChanged to: aContainer.
				im]! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 3/5/2010 09:46'!
inputWidget
	"return the default widget for the input a the setting"
	| inputWidget xtraDialogWidget | 
	xtraDialogWidget := super inputWidget.
	inputWidget :=  self localInputWidgetSelector ifNotNil: [:localSel | self perform: localSel].
	(inputWidget isNil and: [self typeClass notNil])
		ifTrue: [inputWidget := (self inputWidgetSelectorInClass: self typeClass)
			ifNotNil: [:selector | self typeClass perform: selector with: self]].
	inputWidget
		ifNotNil: [(inputWidget respondsTo: #model:) 
			ifTrue: [inputWidget model: self]]. 
	xtraDialogWidget 
		ifNotNil: [inputWidget := inputWidget ifNil: [xtraDialogWidget] 
			ifNotNil: [UITheme current newRowIn: World for: {inputWidget. xtraDialogWidget}]].
	^ inputWidget ! !

!SettingDeclaration methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/29/2010 14:20'!
inputWidgetForBoolean
	^ UITheme current
			newCheckboxIn: World
			for: self
			getSelected: #realValue
			setSelected: #realValue:
			getEnabled: #enabled
			label: '' 
			help: nil! !

!SettingDeclaration methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/29/2010 14:20'!
inputWidgetForColor
	^ (UITheme current
		newColorChooserIn: World
		for: self
		getColor: #realValue
		setColor: #realValue:
		getEnabled: #enabled 
		help: 'Choose a color') minWidth: 150; width: 150; yourself! !

!SettingDeclaration methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 4/21/2010 15:23'!
inputWidgetForFileDirectory
	^ self inputWidgetForFileOrDirectoryWithAction: #chooseFileDirectory.! !

!SettingDeclaration methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 4/21/2010 15:22'!
inputWidgetForFileOrDirectoryWithAction: aSymbol
	^ UITheme current newRowIn: World for: {
					(EditableDropListMorph
						on: self
						list: #list
						selected: #index
						changeSelected: #index:
						useIndex: true 
						addToList: #addToList:
						class: String
						getEnabled: #enabled
						default: self defaultValue)
						ghostText: self ghostHelp;
						width: 450;
						wantsFrameAdornments: true;
						yourself.
					(UITheme current
						newButtonIn: World
						for: self
						getState: nil
						action: aSymbol
						arguments: nil
						getEnabled: nil
						label:  (AlphaImageMorph new image: MenuIcons smallOpenIcon)
						help: 'Open directory chooser dialog' translated)
					}
					! !

!SettingDeclaration methodsFor: 'as yet unclassified' stamp: 'SeanDeNigris 4/21/2010 15:23'!
inputWidgetForFilePath
	^ self inputWidgetForFileOrDirectoryWithAction: #chooseFilePath.! !

!SettingDeclaration methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/29/2010 14:20'!
inputWidgetForFont
	^ (UITheme current
		newButtonIn: World
		for: self
		getState: nil 
		action: #getFont
		arguments: {}
		getEnabled: #enabled
		getLabel: #fontButtonLabel
		help: 'Choose a font ...' translated) cornerStyle: #square
! !

!SettingDeclaration methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/29/2010 14:20'!
inputWidgetForNumber
	^ self inputWidgetForString width: 200.
! !

!SettingDeclaration methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/29/2010 14:20'!
inputWidgetForPassword
	| widget |
	widget := UITheme current
				newTextEntryIn: World
				for: self
				get: #realValue
				set: #realValue:
				class: String
				getEnabled: #enabled
				help: nil.
	widget
		wantsFrameAdornments: true;
		hResizing: #rigid;
		width: 450; 
		font: (StrikeFont passwordFontSize: UITheme current textFont pointSize).
	^ widget! !

!SettingDeclaration methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/29/2010 14:20'!
inputWidgetForPoint
	^ self inputWidgetForString width: 200.
! !

!SettingDeclaration methodsFor: 'as yet unclassified' stamp: 'lr 3/14/2010 21:13'!
inputWidgetForString
	| widget |
	widget := EditableDropListMorph
		on: self
		list: #list
		selected: #index
		changeSelected: #index:
		useIndex: true
		addToList: #addToList:
		class: (Smalltalk globals at: self type)
		getEnabled: #enabled
		default: self defaultValue.
	widget ghostText: self ghostHelp.
	widget contentMorph wantsFrameAdornments: true.
	widget width: 450.
	^ widget! !

!SettingDeclaration methodsFor: 'as yet unclassified' stamp: 'AlainPlantec 1/29/2010 14:21'!
inputWidgetSelectorInClass: aClass 
	| selector |
	^ (aClass respondsTo: (selector := #settingInputWidgetForNode:))
		ifTrue: [selector] ! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/18/2009 23:10'!
list
	^ self class valueListFor: self! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/17/2009 21:20'!
listenersForEvent: anEvent
	| listeners actionSequence |	
	listeners := Set new.	
	actionSequence := self actionMap at: anEvent ifAbsent: [].	
	actionSequence ifNotNil: [
		actionSequence isCollection	 
			ifTrue: [actionSequence do: [:oneAction | 
					oneAction receiver ifNotNil: [:r | listeners add: r]]]
			ifFalse: [listeners add: actionSequence receiver]].
	^ listeners! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 1/29/2010 14:18'!
localInputWidgetSelector
	| imSel |
	^ (self respondsTo: (imSel := ('inputWidgetFor' , self type) asSymbol)) ifTrue: [imSel]! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/6/2009 21:54'!
maxKept
	"maximum number of old values which are kept in
	list instance variable"
	^ 5! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'AlainPlantec 11/25/2009 21:35'!
maxNameWidthForFont: aFont 
	| max |
	max := 0.
	self domainValuesLabels
		do: [:v | max := max max: (aFont widthOfStringOrText: v)].
	^ max ! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 4/8/2009 15:59'!
privateChangeEvent
	^ #privateSettingValueChanged! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:10'!
privateForget: aReceiver 
	"do not notify aReceiver anymore"
	self removeActionsWithReceiver: aReceiver forEvent: self privateChangeEvent! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:50'!
privateForget: aReceiver selector: aSelector 
	"Private"
	self
		removeActionsSatisfying: [:action | action receiver == aReceiver
				and: [action selector = aSelector]]
		forEvent: self privateChangeEvent! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 16:35'!
privateListeners
	^ self listenersForEvent: self privateChangeEvent! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 10:49'!
realValue
	"Answer the value of realValue"

	^ (self settingReceiver perform: self getSelector) 
		ifNil: [self setToDefault. 
			self settingReceiver perform: self getSelector]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 10:49'!
realValue: anObject
	"Set the value of realValue"
	self settingReceiver perform: self setSelector with: anObject.
	self triggerEvent: self privateChangeEvent with: self.! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 13:49'!
selector: aSymbol
	self getSelector: aSymbol.
	self setSelector: (aSymbol, ':') asSymbol.! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'AlainPlantec 11/23/2009 22:36'!
setSelector
	^ setSelector ifNil: [self getSelector ifNotNil: [:gs | (gs, ':') asSymbol]]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 23:07'!
setSelector: aSymbol
	setSelector := aSymbol! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 9/18/2009 09:23'!
setToDefault
	self realValue: self defaultValue.
! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 9/18/2009 09:24'!
type
	"Answer the value of type"

	^ type ifNil: [type := self realValue class name]! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 18:22'!
type: anObject
	"Set the value of type"

	type := anObject! !

!SettingDeclaration methodsFor: 'accessing' stamp: 'lr 3/14/2010 21:13'!
typeClass
	^ Smalltalk globals at: self type ifAbsent: [  ]! !

!SettingDeclaration methodsFor: 'user interface' stamp: 'alain.plantec 4/8/2009 15:59'!
whenPrivateChangedSend: zeroOrOneArgSelector to: aSubscriber 
	"private, use #whenChangedSend:to: instead"
	self
		when: self privateChangeEvent
		send: zeroOrOneArgSelector
		to: aSubscriber! !

PragmaSetting subclass: #SystemSettingLauncher
	instanceVariableNames: 'script'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SystemSettingLauncher methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 13:44'!
defaultIcon
	^ MenuIcons smallDoItIcon! !

!SystemSettingLauncher methodsFor: 'accessing' stamp: 'AlainPlantec 12/12/2009 10:10'!
inputWidget
	^ (UITheme current
				newButtonIn: World 
				for: self
				getState: nil
				action: #launch
				arguments: {}
				getEnabled: nil
				getLabel: nil
				help: self description)
		 		label: (UITheme current newRowIn: World for: {AlphaImageMorph new image: MenuIcons smallRedoIcon. UITheme current buttonLabelForText: 'Launch' translated});
		 		yourself.! !

!SystemSettingLauncher methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 10:51'!
launch
	self script 
			ifNotNil: [:s | s isSymbol 
				ifTrue: [s numArgs = 0 
					ifTrue: [self settingReceiver perform: s]
					ifFalse: [self settingReceiver perform: s with: self]]
				ifFalse: [s numArgs = 0 
					ifTrue: [s value]
					ifFalse: [s value: self]]]! !

!SystemSettingLauncher methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 13:22'!
script
	^ script ifNil: [script := []]! !

!SystemSettingLauncher methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 14:19'!
script: aValuableOrSymbol
	script := aValuableOrSymbol! !

Object subclass: #SettingFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Filter'!

!SettingFilter commentStamp: 'alain.plantec 4/8/2009 12:51' prior: 0!
A SettingFilter is a filter wich is used by a SettingBrowser in order to select which nodes of the setting trees are to be shown. A SettingFilter subclass must redefine the #keepHandler: method which return true if the argument handler is to be kept.

Instance Variables
!

!SettingFilter methodsFor: 'filtering' stamp: 'alain.plantec 9/18/2009 23:46'!
keepSettingTreeNode: aSettingNode 
	^ false! !

SettingFilter subclass: #SettingPackageFilter
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Filter'!

!SettingPackageFilter commentStamp: 'alain.plantec 4/8/2009 12:58' prior: 0!
A SettingPackageFilter is SettingFilter which keeps only handlers with a pragma which defining method belongs to at least one of the given list of packages.

Instance Variables
	packages:		<Collection>

packages
	- The collection of PackageInfo the filter is currently using!

!SettingPackageFilter methodsFor: 'filtering' stamp: 'AlainPlantec 11/27/2009 10:28'!
keepSettingTreeNode: aSettingNode 
	| rp |
	^ (rp := aSettingNode receiverPackage) notNil and: [self packages includes: rp]! !

!SettingPackageFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 23:00'!
packages
	"Answer the value of packages"

	^ packages! !

!SettingPackageFilter methodsFor: 'accessing' stamp: 'alain.plantec 4/8/2009 12:55'!
packages: aCollectionOfPackageInfo
	"Set the value of packages"

	packages := aCollectionOfPackageInfo
! !

SettingFilter subclass: #SettingRegexpFilter
	instanceVariableNames: 'regexp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Filter'!

!SettingRegexpFilter commentStamp: 'alain.plantec 4/8/2009 13:02' prior: 0!
A SettingRegexpFilter is SettingFilter which makes use of a regular expression in order to keep or not a SettingHandler.

Instance Variables
	regexp:		<String>

regexp
	- a regular expression string
!

!SettingRegexpFilter methodsFor: 'filtering' stamp: 'alain.plantec 9/18/2009 23:43'!
keepSettingDeclaration: aSettingDeclaration
	^ ({aSettingDeclaration name. aSettingDeclaration description}
				collect: [:e | e ifNil: ['']])
				anySatisfy: [:token | token substrings anySatisfy: [:sub | sub matchesRegexIgnoringCase: self regexp]]
! !

!SettingRegexpFilter methodsFor: 'filtering' stamp: 'alain.plantec 9/18/2009 23:46'!
keepSettingTreeNode: aSettingNode 
	^ (({aSettingNode methodClass name. aSettingNode selector}
			collect: [:e | e ifNil: ['']])
			anySatisfy: [:token | token substrings anySatisfy: [:sub | sub matchesRegexIgnoringCase: self regexp]])
		or: [self keepSettingDeclaration: aSettingNode settingDeclaration] ! !

!SettingRegexpFilter methodsFor: 'accessing' stamp: 'alain.plantec 4/7/2009 23:52'!
regexp
	"Answer the value of regexp"

	^ regexp! !

!SettingRegexpFilter methodsFor: 'accessing' stamp: 'alain.plantec 4/7/2009 23:52'!
regexp: anObject
	"Set the value of regexp"

	regexp := anObject! !

SettingFilter subclass: #SettingTokenFilter
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Filter'!

!SettingTokenFilter commentStamp: 'alain.plantec 4/8/2009 13:03' prior: 0!
A SettingTokenFilter is SettingFilter which makes use of a token (substring) in order to keep or not a SettingHandler.


Instance Variables
	token:		<String>

!

!SettingTokenFilter methodsFor: 'filtering' stamp: 'alain.plantec 9/18/2009 23:45'!
keepSettingDeclaration: aSettingDeclaration
	^ (({aSettingDeclaration name asUppercase. aSettingDeclaration description asUppercase}
				collect: [:e | e ifNil: ['']])
				includesSubstringAnywhere: self token asUppercase)
! !

!SettingTokenFilter methodsFor: 'filtering' stamp: 'alain.plantec 9/18/2009 23:46'!
keepSettingTreeNode: aSettingNode 
	^ (({aSettingNode methodClass name asUppercase. aSettingNode selector asUppercase}
			collect: [:e | e
					ifNil: ['']])
			includesSubstringAnywhere: self token asUppercase)
		or: [self keepSettingDeclaration: aSettingNode settingDeclaration]! !

!SettingTokenFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:51'!
token
	"Answer the value of token"

	^ token! !

!SettingTokenFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:51'!
token: aString
	"Set the value of token"

	token := aString! !

Object subclass: #SettingNodeBuilder
	instanceVariableNames: 'node builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingNodeBuilder methodsFor: 'private tree building' stamp: 'AlainPlantec 11/24/2009 13:34'!
asParentWhile: aBlock
	builder parent: self while: aBlock
! !

!SettingNodeBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 13:33'!
builder: aTreeBuilder
	builder := aTreeBuilder! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:50'!
default: anObject
	node item  default: anObject
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
description: aText
	node item description: aText! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
dialog: aSymbol
	node item dialog: aSymbol
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
domainValues: aCollection 
	node item domainValues: aCollection 
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
domainValuesGetter: aValuable 
	node item domainValuesGetter: aValuable 
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
getSelector: aSymbol
	node item getSelector: aSymbol
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
ghostHelp: aString
	node item ghostHelp: aString
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
icon: aForm
	node item icon: aForm! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
label: aStringOrBlockOrMessageSend
	node item label: aStringOrBlockOrMessageSend.
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 14:02'!
name
	^ node item name
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
name: aStringOrBlockOrMessageSend
	node item name: aStringOrBlockOrMessageSend.
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/27/2009 23:26'!
noOrdering
	node item noOrdering
! !

!SettingNodeBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 12:43'!
node
	^ node! !

!SettingNodeBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 12:43'!
node: aSettingTreeNode
	node := aSettingTreeNode! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 12/3/2009 16:21'!
notInStyle
	node item notInStyle! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
order: aNumber
	node item order: aNumber
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:51'!
parent: aSymbol
	node parentName: aSymbol! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
parentName
	^ node parentName
	! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
parentName: aSymbol
	node parentName: aSymbol.
	! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 12/5/2009 08:44'!
precondition: aValuable
	node item precondition: aValuable
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
range: anInterval
	node item range: anInterval
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 12/5/2009 13:52'!
script: aSymbol
	node item script: aSymbol
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
selector: aSymbol
	node item selector: aSymbol
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
setSelector: aSymbol
	node item setSelector: aSymbol
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
target: anObject
	node item target: anObject
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/26/2009 21:39'!
targetSelector: aSelector
	node item targetSelector: aSelector
! !

!SettingNodeBuilder methodsFor: 'public declaration accessing' stamp: 'AlainPlantec 11/24/2009 13:52'!
type: anObject
	node item type: anObject
! !

!SettingNodeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 11/24/2009 12:40'!
with: aBlock
	self asParentWhile: aBlock! !

Object subclass: #SettingTree
	instanceVariableNames: 'collector nodeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingTree commentStamp: 'AlainPlantec 11/24/2009 15:21' prior: 0!
A SettingTreeHolder is responsible for the building of system setting trees from a collection of pragma.
Built tree nodes are instances of SettingTreeNode. Built trees are suitable for tree browsing with the help of a MorphTreeMorph (see SettingBrowser>>treeMorphIn: and SettingBrowser>>roots to know how a SettingBrowser is initializing its MorphTreeMorph with the help of a SettingTreeHolder). 

Below, two examples of tree building with a SettingCollector are shown.
---------------
(SettingTreeHolder acceptableKeywords: #('setting')) settingTreeRoots. "get system setting trees"
(SettingTreeHolder acceptableKeywords: #('.*Menu')) settingTreeRoots. "get all menus"
---------------

Instance Variables
	collector		<PragmaCollector>
	nodeList		<A list of SettingTreeNode>
!

!SettingTree class methodsFor: 'instance creation' stamp: 'alain.plantec 4/9/2009 15:50'!
acceptableKeywords: aCollectionOfRegExps 
	^ self new acceptableKeywords: aCollectionOfRegExps 
! !

!SettingTree methodsFor: 'accessing' stamp: 'asasa  4/28/2010 18:33'!
acceptableKeywords: keywords
	self collector filter: [:prg | prg methodClass isMeta and: [keywords includes: prg keyword]].
	nodeList := nil.
	self collector reset.
! !

!SettingTree methodsFor: 'checking' stamp: 'AlainPlantec 11/24/2009 15:11'!
checkForUnknownParent
	self unclassified ifNotEmpty: [:nodesWithUnknownParent | | builder g |
		builder := SettingTreeBuilder new.
		g := (builder group: #nodesWithUnknownParent) node.
		self nodeList addFirst: g.
		g model: self.
		g item label: '*** Unclassified ***'.
		g item icon: MenuIcons smallDebugIcon.
		g item order: 0.0.
		nodesWithUnknownParent do: [:node | node parentName: #nodesWithUnknownParent]]! !

!SettingTree methodsFor: 'checking' stamp: 'AlainPlantec 12/7/2009 08:56'!
checkForUnknownTarget
	"check only root because other nodes with unknown target inherits it from its parent"
	self settingTreeRoots do: [:node | node item target ifNil: [node item target: (node pragma ifNotNil: [:prg | prg methodClass theNonMetaClass])]].
	self settingTreeRoots do: [:node | node checkForUnknownTarget].
! !

!SettingTree methodsFor: 'querying' stamp: 'AlainPlantec 12/9/2009 08:38'!
childrenOf: aNode 
	| children  idx order |
	"Get aNode children. Assign children order if one child has an order which is not nil"
	children := self nodeList select: [:p | p parentName = aNode settingDeclaration name].
	(children detect: [:n | n order notNil] ifNone:[])  ifNotNil: [:firstWithOrder |
		idx := children indexOf: firstWithOrder.
		order := firstWithOrder order.
		idx > 1
			ifTrue: [(idx - 1 to: 1) 
				do: [:pos | 
					(children at: pos) order: order - 1. 
					order := order - 1]].
		order := firstWithOrder order.
		(idx + 1 to: children size) 
			do: [:pos | 
				(children at: pos) order 
					ifNil:  [(children at: pos) order: order + 1] 
					ifNotNil: [order := (children at: pos) order].
				order := order + 1]].
	^ children! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 10/19/2009 11:28'!
collector
	^ collector ifNil: [collector := PragmaCollector new]! !

!SettingTree methodsFor: 'querying' stamp: 'alain.plantec 9/19/2009 09:32'!
deeplyDetect: aBlock 
	self settingTreeRoots
		do: [:sub | (sub deeplyDetect: aBlock)
				ifNotNil: [:found | ^ found]].
	^ nil ! !

!SettingTree methodsFor: 'querying' stamp: 'alain.plantec 4/3/2009 07:53'!
deeplySelect: aBlock
	^ self deeplySelect: aBlock in: OrderedCollection new
! !

!SettingTree methodsFor: 'querying' stamp: 'alain.plantec 4/13/2009 08:04'!
deeplySelect: aBlock in: aCollection 
	self settingTreeRoots
		do: [:aRoot | aRoot deeplySelect: aBlock in: aCollection]. 
	^ aCollection! !

!SettingTree methodsFor: 'private tree building' stamp: 'AlainPlantec 11/27/2009 22:05'!
emptyNodeNamed: aSymbol
	(self nodeNamed: aSymbol)
! !

!SettingTree methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 13:52'!
itemSortBlock
	^ [:a :b | 
		((a order notNil and: [b order notNil]) and: [a order ~= b order])
			ifTrue: [a order < b order]
			ifFalse: [((a order isNil and: [b order isNil]) or: [a order = b order])
				ifTrue: [a label < b label]
				ifFalse: [a order ifNil: [false] ifNotNil: [true]]]]! !

!SettingTree methodsFor: 'accessing' stamp: 'AlainPlantec 12/5/2009 08:46'!
nodeList
	| builder |
	^ nodeList 
		ifNil: [
			builder := SettingTreeBuilder new.
			self pragmasDo: [:p | builder buildPragma: p].
			nodeList := builder nodeList.
			nodeList do: [:n | n model: self].
			self checkForUnknownParent.
			self checkForUnknownTarget.
			self nodeList]! !

!SettingTree methodsFor: 'private tree building' stamp: 'AlainPlantec 11/24/2009 09:35'!
nodeNamed: aSymbol
	^ self nodeNamed: aSymbol ifAbsent: []
! !

!SettingTree methodsFor: 'private tree building' stamp: 'AlainPlantec 11/24/2009 09:34'!
nodeNamed: aSymbol ifAbsent: aBlock
	^ self nodeList detect: [:d | d settingDeclaration name = aSymbol] ifNone: aBlock! !

!SettingTree methodsFor: 'querying' stamp: 'alain.plantec 10/19/2009 13:56'!
pragmasDo: aBlock
	^  self collector do: aBlock! !

!SettingTree methodsFor: 'querying' stamp: 'AlainPlantec 12/5/2009 08:51'!
retainedNodesFromList: aListOfNodes
	| retained |
	retained := OrderedCollection new.
	aListOfNodes do: [:n | [n item precondition value ifTrue: [retained add: n]] on: Error do: [retained add: n]].
	^ retained! !

!SettingTree methodsFor: 'querying' stamp: 'AlainPlantec 12/5/2009 08:51'!
settingTreeRoots
	^ self retainedNodesFromList: ((self nodeList select: [:n | n parentName isNil]) asArray sort: self sortBlock) asOrderedCollection.
! !

!SettingTree methodsFor: 'accessing' stamp: 'AlainPlantec 1/29/2010 13:52'!
sortBlock
	^ [:a :b | self itemSortBlock value: a settingDeclaration value: b settingDeclaration]! !

!SettingTree methodsFor: 'querying' stamp: 'AlainPlantec 11/24/2009 12:01'!
unclassified
	^ self nodeList select: [:node | node parentName notNil and: [node parentNode isNil]].! !

!SettingTree methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 11:51'!
updateList
	nodeList := nil.
! !

!SettingTree methodsFor: 'updating' stamp: 'alain.plantec 10/19/2009 11:37'!
whenChangedSend: aSelector to: aTarget
	self collector whenChangedSend: aSelector to: aTarget.
	self collector whenResetSend: aSelector to: aTarget.! !

Object subclass: #SettingTreeBuilder
	instanceVariableNames: 'nodeList currentParent currentPragma'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingTreeBuilder class methodsFor: 'instance creation' stamp: 'AlainPlantec 11/24/2009 11:53'!
acceptableKeywords: aCollectionOfRegExps 
	^ self new acceptableKeywords: aCollectionOfRegExps 
! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'asasa  4/28/2010 18:21'!
buildPragma: aPragma
	currentPragma := aPragma.
	self perform: aPragma keyword withArguments: aPragma arguments.
	^ nodeList! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 1/29/2010 14:07'!
group: aSymbol
	^ self nodeClass: PragmaSetting name: aSymbol
! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 12/5/2009 13:50'!
launcher: aSymbol
	^ self nodeClass: SystemSettingLauncher name: aSymbol
! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 1/30/2010 11:53'!
nodeClass
	^ SettingNode! !

!SettingTreeBuilder methodsFor: 'private tree building' stamp: 'AlainPlantec 1/30/2010 11:54'!
nodeClass: aClass name: aSymbol
	| node |
	node := self nodeClass with: aClass new.
	node item name: aSymbol.
	node pragma: currentPragma.
	node parentName: (currentParent ifNotNil: [currentParent name]).
	self nodeList add: node.
	^ (SettingNodeBuilder new) node: node; builder: self; yourself! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'AlainPlantec 11/24/2009 12:05'!
nodeList
	^ nodeList ifNil: [nodeList := OrderedCollection new]
! !

!SettingTreeBuilder methodsFor: 'private tree building' stamp: 'AlainPlantec 11/24/2009 13:35'!
parent: aNode while: aBlock
	| oldParent |
	oldParent := currentParent.
	currentParent := aNode.
	aBlock value.
	currentParent := oldParent! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 12/2/2009 11:47'!
pickOne: aSymbol
	^ self nodeClass: PickOneSettingDeclaration name: aSymbol
! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 11/24/2009 12:15'!
range: aSymbol
	^ self nodeClass: RangeSettingDeclaration name: aSymbol
! !

!SettingTreeBuilder methodsFor: 'public tree building' stamp: 'AlainPlantec 11/24/2009 12:15'!
setting: aSymbol
	^ self nodeClass: SettingDeclaration name: aSymbol
! !

!SettingTreeBuilder methodsFor: 'pragmas' stamp: 'AlainPlantec 4/29/2010 17:44'!
systemsettings
	<settingPragmaProcessor>
	"Process a <systemsettings> pragma"
	currentPragma methodClass theNonMetaClass perform: currentPragma selector with: self.! !

!String class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:02'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForString! !
